%%     R.V. Oceanus  ADCP configurations

% set parameters used for logging
% first field is the same as the raw logging directory (eg. os75)
% second field is the ping type (in case of interleaved pings)
% parsed  manually or by running
%    cruise_proc; params = get_params(allparams, 'os75', 'nb');


%%  OS75 processing parameters
os75.ducer_depth  = 5;
os75.h_align = 40.9;    % 45.0 - (xx.x)  (where xx.x is from cal/watertrack)
                        % nominally 45 to port

%---------------------------------
%% OS75, BB pings
% processing  sources:
os75.bb.h_align      = os75.h_align;
os75.bb.ducer_depth = os75.ducer_depth;
os75.bb.velscale     = 1.0;  % <----- no scale factor here
os75.bb.interval     = 300;

% os75.bb.editcfg.weakprof_numbins = 4;

%---------------------------------
%% OS75, NB pings
% processing  sources:
os75.nb.h_align      = os75.h_align;
os75.nb.ducer_depth  = os75.ducer_depth;
os75.nb.velscale     = 1.01;  % <----- scale factor here
os75.nb.interval     = 300;

% os75.nb.editcfg.weakprof_numbins = 2;

%=======================================================

%%%%  NB150 processing parameters
nb150.ducer_depth = 5;
nb150.h_align     = 52.9;  %% nominal - cal watertrk 

% processing  sources:
nb150.nb.h_align      = nb150.h_align;
nb150.nb.ducer_depth  = nb150.ducer_depth;
nb150.nb.interval     = 300;
nb150.nb.beamangle    = 30;


%%%%%%%%%%%% soundspeed correction 
%% applied to ensemble average
%%
%% set velocity scale factor:
%%
%% obsolete: (still works, but deprecated)
%%------------
%%   nb150.nb.velscale = 2.0;
%%
%% newer method:
%  -----------
%  option       what it does
%
% 'calculate'   (calc from thermistor temperature and salinity (below)
%     []         (don't change anything; i.e. use the original 1536 constant)
%   1536        (or some other constant -- use this constant
%               
%                (At some later date we could add soundspeed input directly

nb150.nb.velscale.soundspeed = 'calculate'; 
nb150.nb.velscale.salinity   = 35;         %% if 'calculate', use this S
nb150.nb.velscale.scalefactor = 1.0;     %% also apply this scale factor

%%% to specify a dead beam, use this syntax:
%%% nb150.nb.badbeam   = 4;   % for 3-beam sol; if beam 4 is bad

allparams = struct('os75', os75, 'nb150', nb150);
 
