/*

   FILE:  adcpflag.h

   #defines the different bit-settings for the PROFILE_FLAGS variable in
   ADCP databases

*/

#ifndef profmask_included
#include "profmask.h"        /* ALL_BITS, NO_BITS, BIT_* */
#endif

#ifndef adcpflag_included
#define adcpflag_included

#define GLITCH_BIT                  BIT_0
#define PG_BIT                      BIT_1
#define RANGE_BIT                   BIT_2
#define TEMPORARY_BIT               BIT_7

NAME_LIST_ENTRY_TYPE adcp_profflags[] =
{
   {"glitch_bit", GLITCH_BIT},
   {"pg_bit"    , PG_BIT},
   {"range_bit" , RANGE_BIT},
   {"temporary" , TEMPORARY_BIT},
   {"ALL_BITS"  , ALL_BITS},
   {"NO_BITS"   , NO_BITS},
   {NULL        , 0}     /* list terminator */
};

#endif /* ifndef adcpflag_included */

