% Edit this file and run in matlab from the load/ subdirectory

%choose one to match your instrument type
instclass = os;   
%instclass = bb;


adcppath
rdipath


% You must specify the angle by which to rotate the data collected in beam
% coordinates into earth coordinates.  There is a parameter used during data
% collection 
% h_align = offset_for_heading_used_during_aquisition - codas_correction_value
%   offset_for_heading_used_during_aquisition is EA, under "heading correction"
%   codas_correction_value is the "phase" found in watertrack or bottom track 
% These values might be found from a previous cruise with the same installation
% or by loading the LTA files and running the calibration yourself.  
% Determining this number is a bootstrap operation of sorts.


% to specify the timeranges used for averaging, load a file with 
% ensemble times extracted from the parallel ens processing, eg:
%params.end_dday = read_asc('../../ex0251/edit/a0251.tem', 4,1);
if exist('ensemble.enddday','file')
   tmp=load('ensemble.enddday');
   params.end_dday = tmp(:,1);
end


%for this example, 
params.h_align = 43.28;      % transducer orientation relative to the ship 
params.ducer_depth  = 5;        % transducer pressure 
params.interval = 300;      % averaging interval to use (seconds)
params.ilayer = 2:40;       % reference layer bins (all bins, not the range)
                            %   note: this was a 38Khz instrument and hence a
                            %   very deep reference layer could be used.  
                            %   A better default for a 150Khz or 300Khz 
                            %   instrument might be bins 4:12
params.geometry = 'convex'; % Transducer configuration
                            %   Ocean Surveyors are all 'convex', 
                            %   BroadBand ADCPs are often 'concave'

                            
params.yearbase = 2000;                            
params.pingedit = 1;

% set pingedit parameters
params.editcfg.rl_range = params.ilayer([1 end]);  
params.editcfg.err_cutoff = 1.0;
params.editcfg.errstd_cutoff = 10; %disable
params.editcfg.refavg_valcutoff = 1; 
params.showverbose = 0;
params.editcfg.weakprof_binsreq = 10;
params.editcfg.weakprof_testrange = [1:12];



pingpath = '../ping';

r = [];

pingpath = '../ping';
files = dirs(fullfile(pingpath, '*.ens'),'sort', 'time');


for ifile = 1:length(files)
   file = fullfile(pingpath, files(ifile).name)
   r = load_raw(instclass, file, params, 'finish', 0, 'leftover', r);
end
