#! /usr/bin/env python

''' link ens* files to the current directory with new names by
    incrementing from the last existing name

    Usage: link_ens.py sourcedir

'''

import sys, os, os.path, re, string, glob, shutil

if len(sys.argv) == 1:
   print 'usage:'
   print __doc__
   sys.exit()

if len(sys.argv) > 1:
   sourcedir = sys.argv[1]
   if not os.path.isdir(sourcedir):
      print "source directory %s does not exist" % (sourcedir)
      sys.exit()

print "getting files from %s" % (os.path.join(sourcedir, 'ens*.cmd'))
filelist = glob.glob(os.path.join(sourcedir, 'ens*.cmd'))

if len(filelist) == 0:
   print 'no files found in %s with globstr "%s"' % (sourcedir, globstr)
   sys.exit()


nowlist = glob.glob('ens*.cmd');
if nowlist == []:
   nownums = [0]
else:
   nownums = []
   for cmdfile in nowlist:
      nownums.append(int(cmdfile[-7:-4]))
   nownums.sort()

newblk = max(nownums) + 1


for filename in filelist:
   orig_fullbase = filename[0:-4]
   for ext in ('cmd', 'log', 'bin', 'gps1', 'gps2', 'mat'):
      fromfile = '%s.%s' % (orig_fullbase, ext)
      if os.path.exists(fromfile):
         tofile = 'ens_blk%03d.%s' % (newblk, ext)
         print 'linking %s to %s'% (fromfile, tofile)
         os.symlink(fromfile, tofile)
   newblk = newblk + 1

      
   
