@ECHO off
REM ***************************************************************************
REM    FILE:  adcptree.bat
REM    USAGE: adcptree [ path-name\ ]cruise-name  [ CODAS path ]
REM    Batch file for setting up a subdirectory system for a new ADCP
REM    database and automatically copying the required control and .M files
REM    to the appropriate subdirectories.  The command line argument must
REM    specify the pathname (optional), and cruise name (e.g., MW8901) as
REM    a single string; the cruise name should have no more than 8 characters.
REM    If the CODAS subdirectory is not under the root directory of the
REM    current drive, its path must also be given on the command line.
REM **************************************************************************
IF "%1"=="" GOTO error
ECHO on
mkdir %1
mkdir %1\adcpdb
mkdir %1\cal
mkdir %1\cal\watertrk
mkdir %1\cal\botmtrk
mkdir %1\cal\heading
mkdir %1\cal\rotate
mkdir %1\contour
mkdir %1\edit
mkdir %1\grid
mkdir %1\load
mkdir %1\nav
mkdir %1\ping
mkdir %1\quality
mkdir %1\scan
mkdir %1\stick
mkdir %1\vector
copy %2\codas3\adcp\demo\adcpdb\*.def       %1\adcpdb
copy %2\codas3\adcp\demo\adcpdb\*.cnt       %1\adcpdb
copy %2\codas3\adcp\demo\cal\watertrk\*.cnt %1\cal\watertrk
copy %2\codas3\adcp\demo\cal\watertrk\*.m   %1\cal\watertrk
copy %2\codas3\adcp\demo\cal\botmtrk\*.cnt  %1\cal\botmtrk
copy %2\codas3\adcp\demo\cal\botmtrk\*.m    %1\cal\botmtrk
copy %2\codas3\adcp\demo\cal\heading\*.m    %1\cal\heading
copy %2\codas3\adcp\demo\cal\rotate\*.cnt   %1\cal\rotate
copy %2\codas3\adcp\demo\cal\rotate\*.m     %1\cal\rotate
copy %2\codas3\adcp\demo\contour\adcpsect.cnt      %1\contour
copy %2\codas3\adcp\demo\contour\contour.cpa      %1\contour
copy %2\codas3\adcp\demo\edit\*.cnt         %1\edit
copy %2\codas3\adcp\demo\edit\*.m           %1\edit
copy %2\codas3\adcp\demo\edit\*.m__         %1\edit
copy %2\codas3\adcp\demo\grid\llgrid.cnt    %1\grid
copy %2\codas3\adcp\demo\grid\timegrid.cnt  %1\grid
copy %2\codas3\adcp\demo\load\*.cnt         %1\load
copy %2\codas3\adcp\demo\nav\*.cnt          %1\nav
copy %2\codas3\adcp\demo\nav\*.m            %1\nav
copy %2\codas3\adcp\demo\nav\*.m__          %1\nav
copy %2\codas3\adcp\demo\ping\*.m           %1\ping
copy %2\codas3\adcp\demo\quality\*.cnt      %1\quality
copy %2\codas3\adcp\demo\quality\*.m        %1\quality
copy %2\codas3\adcp\demo\scan\*.cnt         %1\scan
copy %2\codas3\adcp\demo\scan\*.def         %1\scan
copy %2\codas3\adcp\demo\scan\*.m           %1\scan
copy %2\codas3\adcp\demo\stick\*.cnt        %1\stick
copy %2\codas3\adcp\demo\stick\*.m          %1\stick
copy %2\codas3\adcp\demo\vector\*.cnt       %1\vector
copy %2\codas3\adcp\demo\*.prl              %1
copy %2\codas3\adcp\doc\edit_doc\aREADME*.txt    %1\edit


@ECHO off
GOTO end
:error
ECHO ERROR: Invalid no. of parameters on command line
ECHO USAGE: adcptree [ pathname\ ]cruise-name  [ CODAS path ]
:end
ECHO Batch job terminated

