@ECHO off
REM ***************************************************************************
REM    FILE:  maketree.bat
REM    USAGE: maketree [ path-name\ ]cruise-name  [ CODAS path ]
REM    Batch file for setting up a subdirectory system for an new ADCP
REM    database and automatically copying the required control and .M files
REM    to the appropriate subdirectories.  The command line argument must
REM    specify the pathname (optional), and cruise name (e.g., MW8901) as
REM    a single string; the cruise name should have no more than 8 characters.
REM    If the CODAS subdirectory is not under the root directory of the
REM    current drive, its path must also be given on the command line.
REM **************************************************************************
IF "%1"=="" GOTO error
ECHO on
mkdir %1
mkdir %1\adcpdb
mkdir %1\contour
mkdir %1\grid
mkdir %1\quality
mkdir %1\stick
mkdir %1\vector
mkdir %1\util
copy %2\codas3\cntfiles\as_con.cnt      %1\contour
copy %2\codas3\cntfiles\contour.cpa      %1\contour
copy %2\codas3\cntfiles\llgrid.cnt    %1\grid
copy %2\codas3\cntfiles\timegrid.cnt  %1\grid
copy %2\codas3\cntfiles\arrdep*.cnt  %1\grid
copy %2\codas3\cntfiles\profstos.cnt      %1\quality
copy %2\codas3\cntfiles\profstuw.cnt      %1\quality
copy %2\codas3\mfiles\stn_udw.m      %1\quality
copy %2\codas3\cntfiles\as_con.cnt          %1\stick
copy %2\codas3\mfiles\runstick.m          %1\stick
copy %2\codas3\cntfiles\mkblkdir.cnt        %1\util
copy %2\codas3\cntfiles\lst*.cnt        %1\util
copy %2\codas3\cntfiles\as_sub.cnt        %1\util
copy %2\codas3\cntfiles\as_vec.cnt       %1\vector
copy %2\codas3\cntfiles\vector.cnt       %1\vector

@ECHO off
GOTO end
:error
ECHO ERROR: Invalid no. of parameters on command line
ECHO USAGE: maketree [ pathname\ ]cruise-name  [ CODAS path ]
:end
ECHO Batch job terminated

