#!/usr/bin/python

#### documentation ###

# quick_adcp.py documentation:
#
# print_howto_ping():
# print_howto_LTA():                NOT YET WRITTEN!!
# print_vardoc():
# print_overview():

# print_pingdata_commands():
# print_lta_commands():
# print_lastfiles_commands():

# print_singleping_commands():
# print_enx_commands():
# print_hdss_commands():
# print_uhdas_commands():


# print_setup_info():


def print_pingdata_commands():
   str = '''
  =======================================================================
                    == Narrowband pingdata files ======

   To process NB pingdata (assuming  300-second ensembles)
   (1) run
                 adcptree.py vg0304
   (2) change directories to newpingdemo/ping and link or copy the pingdata files here
   (3) then "cd .." to get back to  the processing directory 
   (4a) Now: (for example)

   quick_adcp.py --cntfile q_py.cnt

   ###   q_py.cnt is 
   --yearbase 2003                            ### for decimal day conversion
   --dbname a0304                             ### database name, in adcpdb
   --use_refsm                                ### could use --use_smoothr
   --datatype pingdata                        ### this is the default
   --datafile_glob pingdata.???               ### DO NOT quote the wildcards
   ### end of q_py.cnt

   (4b) calibration (watertrack and bottomtrack)
   
   quick_adcp.py --cntfile  q_pyrot.cnt

   ### start q_pyrot.cnt
   --yearbase 2003                            ### for decimal day conversion
   --use_refsm                                ### could use --use_smoothr
   --rotate_angle .4                          ### rotation (cal/watertrk/adclcal.out)
   --steps2rerun rotate:navsteps:calib        ### do these steps
   --auto
   
   (4c) after editing:

   quick_adcp.py --cntfile  q_pyedit.cnt

   ## q_pyedit.cnt is:
   --yearbase 2003                            ### for decimal day conversion
   --use_refsm                                ### could use --use_smoothr
   --steps2rerun apply_edit:navsteps:calib:matfiles  ### do these steps
   --auto
   ### end of q_pyedit.cnt

NOTE to Windows users: replace 'quick_adcp.py' with 'quickadcp_py' and
                       replace 'adcptree.py' with 'adcptree_py'.  These
                       are .BAT files that set enviroment variables and
                       call the respective python versions.

  ========================================================================
'''
   print str

#--end  print_pingdata_commands-------------------------------------------------------

def print_lta_commands():

   str = '''
  ========================================================================
                 == Ocean surveyor LTA or STA files ======
                                             
   (for example, no frills)
   
   To process LTA averaged data with 300-second ensembles,
   (1) run
             adcptree.py vg0404 --instclass os --datatype lta

   (2) change directories to vg0301/ping and link or copy the LTA files here
   (3) then "cd .." to get back to  the cruise directory.
   (4a) Now:  (for example)

      quick_adcp.py --cntfile q_py.cnt

   ### q_py.cnt is
   --yearbase 2004                       # for decimal day conversion
   --dbname a0404                        # database name; in adcpdb
   --use_refsm                           # could use --use_smoothr
   --instname os38                       # instrument name (for matlab files)
   --instclass os                        # instrument type
   --datatype lta                        # datafile type
   --datafile_glob *.LTA                 # filename extension
   ### end of q_py.cnt

   (4b) calibration(watertrack and bottom track)

   quick_adcp.py --cntfile  q_pyrot.cnt

   ### q_pyrot.cnt is:
   --yearbase 2004                       # for decimal day conversion
   --use_refsm                           # could use --use_smoothr
   --instname os38                       # instrument name (for matlab files)
   --rotate_angle 1.2                    # phase correction
   --steps2rerun rotate:navsteps:calib   # apply rotation
   --auto                                # be speedy (don\'t ask yes or no)
   ### end of q_pyrot.cnt

   quick_adcp.py --cntfile  q_pyedit.cnt

   ## q_pyedit.cnt is:
   --yearbase 2004                       # for decimal day conversion
   --instname os38                       # instrument name (for matlab files)
   --use_refsm                           # could use --use_smoothr
   --steps2rerun apply_edit:navsteps:calib:matfiles  # do these steps
   --auto                                 # be speedy
   ### end of q_pyedit.cnt

   
NOTE to Windows users: replace 'quick_adcp.py' with 'quickadcp_py' and
                       replace 'adcptree.py' with 'adcptree_py'.  These
                       are .BAT files that set enviromennt variables and
                       call the respective python versions.

  ========================================================================

'''

   print str

#---end print_lta_commands---------------------------------------------------------

def print_lastfiles_commands():

   str = '''
  ========================================================================
  Description: This mode of quick_adcp.py is designed to "incrementally" process
  LTA or pingdata files as they are generated during a cruise.  (The other mode
  would be called "batch" mode, since all files are processed at the same time.)
  Using the  "lastfiles" option with these files should work fine.

  For averaged data files, (pingdata, STA, or LTA), a new block starts with the
  beginning of each file (though a file may generated more than one block).
  Using the "lastfiles" option with single-ping data may be somewhat problematic.

  In any case, a good general rule is "Always make sure to back up enough to
  REDO the last file loaded during any previous call to quick_adcp.py"  


  ========================================================================
      == example for daily (incremental) processing of LTA files ==
                          (unix only)
      
   (for example, no frills)
   
   To process LTA averaged data (assuming 300-second ensembles)
   (1) run
               adcptree.py vg0301 --instclass os --datatype lta
                  
   (2) - identify the directory with the data (probably an smbmount; LTADIR)
       - figure out how many files are written out in a day (say 3)

   (3) Now, every 12 hours:

   quick_adcp.py --cntfile q_py.cnt --auto

   #### begin q_py.cnt
   ## all lines after the first "#" sign are ignored
   --yearbase 2003                         # for correct decimal day conversion
   --dbname a0301                          # database is in adcpdb
   --instname os75                         # for matlab files
   --use_refsm                             # could specify --use_smoothr
   --datatype lta                          # specify data type
   --instclass os                          # specify instrument
   --lastfiles 2                           # for incremental processing
                                           # BE SURE REDO enough files
   --datadir  LTADIR                       # data directory (example)
   --datafile_glob "*.LTA"                 # wildcard expansion in datadir
   ## end of q_py.cnt
   
   ========================================================================
'''

   print str
#-- end print_lastfiles_commands------------------------------------------------------


def print_enx_commands():

   str = '''
   ========================================================================
             == Ocean surveyor ENX files ======

   (for example, no frills)
   WARNING:  - You must know the transducer depth and the transducer angle (use
             \'read\' in matlab to find them from the LTA or STA data)
   
   To process ENX (single-ping, earth coordinates) data with 300-second
   averages,  Ocean Surveyor data, "bb" pings

   (1) run
          adcptree.py vg0404 --instclass os --pingtype nb --datatype enx

   (2) change directories to vg0404/ping and link or copy the LTA files here
   (3) then "cd .." to get back to  the cruise directory.
   (4) Now: (note that the averaging step ('load') may take several hours..)
   (4a) Now:  (for example)

      quick_adcp.py --cntfile q_py.cnt

   ### q_py.cnt is
   --yearbase 2004                       # for decimal day conversion
   --dbname a0404                        # database name; in adcpdb
   --ducer_depth 7                       # ENX needs transducer depth
   --use_refsm                           # could use --use_smoothr
   --instname os38                       # instrument name (for matlab files)
   --instclass os                        # instrument type
   --datatype enx                        # datafile type
   --pingtype  bb                        # specify nb or bb
   --datafile_glob *.ENX                 # filename extension
   ### end of q_py.cnt


   (4b) calibration(watertrack and bottom track)

  quick_adcp.py --cntfile  q_pyrot.cnt


    ### q_pyrot.cnt is:
   --yearbase 2004                       # for decimal day conversion
   --instname os38                       # instrument name (for matlab files)
   --use_refsm                           # could use --use_smoothr
   --rotate_angle 1.2                    # phase correction
   --steps2rerun rotate:navsteps:calib   # apply rotation
   --auto                                # be speedy (don\'t ask yes or no)
   ### end of q_pyrot.cnt

   quick_adcp.py --cntfile  q_pyedit.cnt

   ## q_pyedit.cnt is:
   --yearbase 2004                            # for decimal day conversion
   --instname os38                            # instrument name (for matlab files)
   --use_refsm                                # could use --use_smoothr
   --steps2rerun apply_edit:navsteps:calib:matfiles  # do these steps
   --auto                                     # be speedy
   ### end of q_pyedit.cnt

   
NOTE to Windows users: replace 'quick_adcp.py' with 'quickadcp_py' and
                       replace 'adcptree.py' with 'adcptree_py'.  These
                       are .BAT files that set enviromennt variables and
                       call the respective python versions.


   ========================================================================

'''

   print str

#-- end print_enx_commands--------------------------------------------------------

def print_singleping_commands():

   print 'single ping overview'

   str = '''
   ========================================================================
             == single-ping ADCP data ======

      Single-ping raw data files can be read with matlab programs in the
      UH CODAS processing suite.  The on-line html documentation provides
      more detail than is possible here.

      Overview:
      An ADCP produces records in a binary file. UH CODAS procssing includes
      a matlab "read" function for raw data generated by 4-beam Doppler sonars
      manufactured by Sontek, RDI (all, as far as I know, including
      Ocean Surveyor, Workhorse, Broadband, Narrowband), and HDSS (50kHz and 140kHz
      sonars on the Revelle; this software worked once but is not actively supported)

      Doppler data can be though of as having three stages:
      (1) single-ping (highest time resolution) data, straight from the instrument
      (2) single-ping NAVIGATED data, i.e. same time resolution as #1 but including
             nice features such as UTC time, position, heading, (pitch+roll).
             NAVIGATED single-ping data comes from a data acquisition system
      (3) averaged (usually averages of #2)

      The UH CODAS processing "read" can read most of these.  
      
      Details:
      (1) raw single-ping data:
        For self-contained (moored or lowered) instruments, you download a file
        from  the recorder.  (Although averaging may take place in the instrument,
        for the purposes of this discussion these data are still referred to as
        "single-ping", though RDI terminology is more like "single-ensemble".  In
        any case, this refers to the finest time resolution available in the
        data coming from the instrument.
        
        For a direct-reading (shipboard) systems, a data acquisition system continually
        obtains the data from the instrument, updating files on a disk.  These data
        really are single-ping in the sense that no averaging was done by the instrument.

        UH matlab "read" can handle all the raw data mentioned above.

        Data in this category are:
        - LADCP or moored data (if 4 beams)
        - RDI ADCP ENR data collected by VmDAS
        - RDI ADCP "raw" data collected by UHDAS

      (2) navigated single-ping data:
        These come from two sources only:
        - VmDAS ENS files (with UTC time and navigation, but in beam coordinates)
        - VmDAS ENX files (with UTC time and navigation, in earth coordinates)
        - HDSS files  (with UTC time and navigation, in earth coordinates)
        - (UHDAS single-ping data can be loaded with navigation using tools
              available in the UHDAS CODAS software)
        - (there is no mechanism for reading navigated Transect data)

      (3) averaged files:
        - LTA, STA (VmDAS averages)

      There is no matlab "read" for pingdata (though there is ping2mat executable)
      There is no matlab "read" for Transect averages

      ---------------
      CODAS processing of ADCP data consists of three stages.
      (I) read, "navigate" (find UTC time, add position and attitude), edit, and
          average the single-ping data
      (II) load the averages into CODAS, find and smooth the reference layer,
              obtain a gps-based heading correction for the gyro headings,
              determine preliminary angle and amplitude calibrations from
              watertrack and/or bottom track data (using corrected headings)
      (III) editing (bottom interference, wire interference, bubbles, ringing,
              identifying problems with heading and underway bias), final calibration
              based on edited data


      If you start with LTA, STA, or pingdata, you are starting at (II).  What
      _used_ to be known as CODAS processing is really steps II and III.  With the
      access to VmDAS single-ping data, (ENS or ENX) we have the opportunity to do a
      better job editing  at the single-ping stage.  With UHDAS and HDSS data, we are
      required to start with single-ping data.

      If you start with single-ping data (stage I), you should already be familiar
      with stages II and III.

'''
   print str


#-- end print_singleping_commands--------------------------------------------------------



def print_hdss_commands():

   str = '''
   ========================================================================
             == Pinkel Sonar Hdss files ======

   Your Mileage May Vary: this is unsupported sofware (it was developed out
   of necessity, but is not actively being used or developed)

   (for example, no frills)

   (1) run
          adcptree.py vg0501 --datatype hdss

   (2) change directories to vg0501/ping and link the files into this
          directory with the python program "link_hdss.py"
          - this will create files that sort correctly in ascii order
          - remember to escape the wildcard, eg:
                  make a directory vg001/data
                  copy the data to that directory
                  cd vg0501/ping
                  run: "link_hdss.py ../data 50\\*"
                  
   (3) then "cd/load" and edit "hdss_params.m" for your dataset
             Look at load_hrdata.m: if anything needs to be edited,
             do so, and run this step by hand (otherwise quick_adcp.py
             will make a copy like this one and run it)
       In matlab, in the load directory, run "load_hrdata"
   (4) then "cd .." back to the processing directory
   (5) When you get to the 'scan' stage,  go to another window and look at the
            output files *.tr and *.scn to make sure you have the
            'yearbase' and 'log_yearbase' right.
   (6) When you get to the 'load' stage, skip the 'make cmd and bin' stage
       Say 'yes' to 'load cmd and bin into codas database'
       Proceed with the remainder of the steps.
   (7)For example
      quick_adcp.py --cntfile q_py.cnt

   ### q_py.cnt is
   --yearbase 2005                       # for decimal day conversion
   --log_yearbase  2003                  # accounts for a bug in hdss acquisistion
   --dbname a0501                        # database name; in adcpdb
   --use_refsm                           # could use --use_smoothr
   --instname hr50                       # instrument name (for matlab files)
   --datatype hdss                       # datafile type
   ### end of q_py.cnt


  quick_adcp.py --cntfile  q_pyrot.cnt



WARNING:  -
      At the time of writing (2/2005), the 50KHz instrument was down to
      2 beams and the 140KHz instrument was down to 3.  This is a bit of an
      experiment, to see what we can get out of the Hdss sonars.  You
      are advised to take a look at your data with \'read\' in matlab,
      and will want to log the narrowband data as well, if possible.
      Specifically, note the field \'dday\' and set "log_yearbase"
      to the year it appears those numbers were generated.  Fiddle
      with "read" until your log_yearbase and "yearbase" give you
      the correct (zero-based) decimal yearday.
      
      This addition to quick_adcp.py is not as automatic as most others,
      so watch for instructions below.  Check the links in 
      "adcp_processing.html" in the processing directory.

      With the 2-beam solutions of the hr50, it is necessary to do more
      processing afterwards and the velocities may still not look great.
      It is recommended that the concurrent NB150 dataset be used. 

      With the 3-beam solutions of the hr140, the data look better, but
      there will still be additional post-processing necessary.

      Information about calibration and editing is present in other sections
      dealing with different instruments.  Two-beam solutions yield velocities
      fraught with error.

NOTES: You are running unsupported software  You are brave.  You are stuck.
       Best of luck.  If you\'re serious about getting HDSS data into codas
       I may be able to help, but this is not a task for the faint of heart.

      Prequisites:
      (1) You should already know how to process pingdata or LTA data with this
          suite (quick_adcp.py + CODAS), i.e. stages II and III.  You
          need to know how to recognize bad velocities.  
          
      (2) You should know how to process ENX data and be familiar with the
          data in ENX files.  The HDSS code was hacked from the ENX code.
          See the on-line help (or adcp_processing.html, created when you run
          adcptree.py).  See also single-ping documentation, starting with
          this decription:

          "quick_adcp.py --commands singleping

      (3) Energy, hope, enthusiasm, dogged persistence.
          There are undoubtably bugs in the code, the HDSS data format has its
          own bugs and may have changed since this version was written, and
          it\'s not clear what the quality of the velocities will be once
          you\'re done.  But the vertical shears should be good.          


   ========================================================================

'''

   print str

#---end print_hdss_commands----------------------------------------------------------

def print_ens_commands():

   str = '''
   ========================================================================
             == Ocean surveyor ENS files ======

   (for example, no frills)
   WARNINGS:
     - You must have gyro heading coming directly into your deck unit
             or this won\'t work.  Advise using ENX data instead
     - This is essentially the same as ENX except that 
             (1) it uses the gyro heading 
             (2) you must know the heading alignment of the transducer
             (3) you must know the transducer depth
     - Find the transducer depth and the transducer angle (use
             \'read\' in matlab to find them from the LTA or STA data)
   
   To process ENS (single-ping, beam coordinates) data with 300-second
   averages,  Ocean Surveyor data, "nb" pings

   (1) run
            adcptree.py vg0404 --instclass os --pingtype nb --datatype ens

   (2) change directories to vg0404/ping and link or copy the LTA files here
   (3) then "cd .." to get back to  the cruise directory.
   (4) Now: (note that the averaging step ('load') may take several hours..)

   quick_adcp.py --yearbase 2004  --dbname a0404 --use_refsm \\
   --ducer_depth 7  --ens_halign 45 \\
   --datatype ens --instclass os --pingtype nb  --datafile_glob "*.ENS"
   
   and to recalibrate: (example with angle correction 1.3)
   
   quick_adcp.py --yearbase 2003 --use_refsm --rotate_angle 1.3  \\
   --steps2rerun rotate:navsteps:calib

   and after editing,

   quick_adcp.py --yearbase 2003 --use_refsm  \\
   --steps2rerun apply_edit:navsteps:calib:matfiles --auto
   

   
NOTE to Windows users: replace 'quick_adcp.py' with 'quickadcp_py' and
                       replace 'adcptree.py' with 'adcptree_py'.  These
                       are .BAT files that set enviromennt variables and
                       call the respective python versions.

   ========================================================================

'''

   print str

#-- end print_ens_commands ------------------------------------------------------------

def print_uhdas_incremental_commands():

   str = '''
  ========================================================================
  Description: This mode of quick_adcp.py is designed to "incrementally" process
  UHDAS files as they are generated during a cruise.  (The other mode would be called
  "batch" mode, since all files are processed at the same time.)
  
  For UHDAS data files,  a new block starts when a configuration is changed
  (which corresponds to the beginning of a file) or when the previous block 
  is full (which can occur in the middle of the file).  The matlab averaging
  program (write_blk.m) is incremental in nature, so its output (prefix ens_blkNNN)
  (suffixes .log, .bin, .cmd, .gps1, .gps2) files need not be rewritten.

  Use "--blkfiles 1" to indicate that the last block file from the database should
  be deleted, and because addition to the averaged data is incremental, everything
  should work.

  ========================================================================
      == example for typical processing of UHDAS files ==
                          (unix only)
      
   #### begin q_py.cnt

   --yearbase    2005
   --pingtype    bb
   --cfgbase     km0507
   --cruisename  km0507
   --instclass   os
   --instname    os38
   --dbname      a_km
   --datatype    uhdas 
   --datadir     /home/data/km0507/raw/os38
   --cfgpath     /home/data/km0507/proc/os38bb/config 
   --ens_len     300 
   --ping_headcorr                           #  DO NOT use post_headcorr for incremental
   --hcorr_inst  posmv                       # use posmv for correction
   --delblks     1                           # delete one block before loading
   --skip_avg                                # averages are done with 5-min profile plots
   --use_refsm 
   --find_pflags 
   --hidedisplay  
   --firstdepth  45
   --auto

   ## end of q_py.cnt
   
   ========================================================================
'''

   print str


#--end print_uhdas_incremental_commands-------------------------------------------


def print_uhdas_commands():   

   str = '''
   
   ==== UHDAS bb pings ================    unix only


      
   (for example, no frills)
   
   To process raw data (assuming 300-second ensembles)
   (0) setup:
       (a) The raw/ and gbin/ files must exist.  see the web documentation for details
       (b) A config directory must exist with files properly configured.
           This example is a short version of the demo in the web documentation,
           and assumes an overall working directory with config/ subdirectory
           and processing directories for each instrumetn type.  Here is the
           OS38nb example:
   
   (1) make processing directory:

   
   adcptree.py  os38nb  --instclass  os --instname os38 --pingtype nb \
     --datatype uhdas --configbase km0507 --configpath config

 
   (2) run quick_adcp.py (batchmode)

   quick_adcp.py --cntfile q_py.cnt


   #### begin q_py.cnt
   ## all lines after the first "#" sign are ignored
     --yearbase    2005
     --pingtype    nb                           ## this is different for os38nb
     --cfgbase     km0507
     --cruisename  km0507
     --instclass   os
     --instname    os38
     --dbname      a_km
     --datatype    uhdas
     --datadir     /home/jules/km0507/data/raw/os38
     --cfgpath     config
     --ens_len     300
     --ping_headcor
     --hcorr_inst    posmv
     --use_refsm
     --firstdepth  45                           ## this is deeper for os38nb
   ## end of q_py.cnt


     rotate, edit as usual.
     See web documentation for notes on heading correction

'''

   print str

#----- print_uhdas_commands -----------------------------------------------------------


def print_tips():
   
   str = '''

- VmDAS data configurations

  You can run the following before starting to get configuration
  information.  There are three steps, all run in matlab.  This example is
  for LTA files, but it can be run on any VmDAS files.  The os below refers
  to "ocean surveyor" (if you had a broadband, you would use bb instead).
  NO QUOTES on bb -- it is a class not a string.
  DO NOT name a variable bb, nb, or os
  
  (1) get a file list:   
             filelist =   dirs('/path_to_data/datadir/*ENS','fullfile',1);
  (2) get the configuration information into a structure:
             cc=get_configs(os,'filelist',filelist);
  (3) write it out:
             write_configs(cc);



'''

   print str


#----end print_tips -------------------------------------------------------------------------


def  print_template_textfile(outfile=None):

   str = '''

LAST CHANGED    : Fri Aug 20 11:29:48 HST 2004

CRUISE          : vg0407,  'PACDEV'
CRUISE DATES    : 2004/05/17  19:00:56 to 2004/05/21  17:36:03
PORTS           : Honolulu to Honolulu
CHIEF SCIENTIST : Joe Schmoe
DB_NAME         : a0407
DATA FILES      : vg2004_137_68156 - vg2004_141_57600
STATUS          : averaged, loaded, edited, heading corrected, done.

INSTRUMENTs     : OS38

ACQUISITION     
     PROGRAM    : UHDAS

     PING TYPE  : narrowband (from interleaved)
                  (specify narrowband vs narrowband here)
      PARAMS    : blank=            16  (BK) (see adcpdb/\*cnh after first pass)
                  pulse =           16  (PL)
                  bin length=       24  (BL)
                  number of bins=   60  (NB) 
HEADING         
     PRIMARY    : gyro
     CORRECTION : ashtech

POSITIONS       : pcode

CALIBRATION     : 0.0 phase, 1.00 amplitude; 
                : original heading alignment: 41.9
                :     from (45 - cal/watertrk)
                
COMMENTS        : No ashtech gaps

PROCESSOR       : I.M.Persistent

(write additional instructions or notes about processing below...)

'''


   if outfile is None:
      print str
   else:
      OO = open(outfile,'w')
      OO.write(str)
      OO.close
   
#--- end print_template_textfile  --------------------------------------------------------------


def print_overview():
   
   str = '''

Quick_adcp.py is a python script that runs all the usual CODAS processing steps,
providing a good place to start processing ADCP data.  For data sets with
no glitches (i.e. all the navigation is present, no repeated timestamps, data files
sorted in ascii order are also in time order, etc), this will allow fast,
documented, and repeatable processing for a first look at the data or if you\'re
lucky, for final processing.  This includes setting up the editing directory
so \'gautoedit\' will run.  
The entire dataset can usually be processed completely with just the following:
- adcptree.py (to set up the processing directory)
- quick_adcp.py (to do the processing, and redo steps)
- gautoedit (to do the editing)

NOTE to Windows users: replace 'quick_adcp.py' with 'quickadcp_py' and
                       replace 'adcptree.py' with 'adcptree_py'.  These
                       are .BAT files that set enviromennt variables and
                       call the respective python versions.


Quick_adcp.py uses commandline arguments to specify input information (file
names, database name, yearbase, etc).  You can skip a step by typing \'n\'
(for \'no\', do not do it) or you can stop at any stage by typing \'q\'
(for \'quit\').  A log is kept as steps are run; it is the processing directory and
has a suffix ".runlog"

   
assumes
  - adcptree.py was already run (see adcptreey.py for help)
        Be sure to specify datatype and instclass if necessary
  - quick_adcp.py is run from the adcp processing directory (PROCDIR)
       - it writes a log of steps run and values used (see
         PROCDIR/CRUISENAME.runlog)
  - data location depends on data type, as follows:
      - default is PROCDIR/ping
           pingfile note:  "linkping.py" is useful to link pingdata from
           other locations to ./ping as ascii-sortable pingdata.* (unix only)
  - data files are found by using the default directory or specified
           directory (\'datadir\') and wildcard expansion  \'datafile_glob\'
            MAKE SURE TO PUT QUOTES AROUND THE WILDCARD STRING USED
  - sets up new "gautoedit" files:
       -  makes asetup.m aflagit_setup.m  in edit/
       - (optionally) makes setup.m in edit/ with all thresholds (except
          bottom) disabled.  This is useful if you are going to use the
          old waterfall editing strictly as a tool to _manually_ flag
          bins or profiles but don\'t want it to guess what to flag.
  - makes and runs setflags.tmp with PG cutoff set
  - allows frequently-run steps to be rerun without querying (specifically,
          applying editing flags, rerunning nav steps, rerunning calibration,
          making new matlab files for plotting
          

CODAS shipboard ADCP processing steps:  (see process.txt for details)
  - scan: get the time range of the scanned data
  - load: put the data in the database, get the time range of the database
  - (set up gautoedit files, run setflags to flag bad PG at the outset)    
  - ubprint (for pingdata)         (or cat navigation if VMDAS or UHDAS)
  - ashrot  (for pingdata)
  - rotate
  - nav steps:     (choose to use either refsm or smoothr for navigation.)
           adcpsect              # these three must be run anyway for
           refabs                #   reflayer diagnostic plots and
           smoothr               #   watertracking or recip to work)
           (refsm, if specified)
  - plot reference layer (default:bins 4-12, or specified on command line)
  - putnav;              (uses whatever was specified: refsm or smoothr)
  - watertrack
  - bottom track
  - lists and plots temperature
  - timegrid (for standardized matlab files)
  - standardized matlab vector and contour files

apply calibrations to  ADCP data:
  (you have to look at the watertrack and bottom track calibration
       to see what rotation or amplitude factors might be necessary)
  (you have to go into edit/ and run gautoedit to remove the bad data)
  (then reprocessing uses "steps2rerun" to run these steps
  "rotate"     - rotate
  "navsteps"   (choose either refsm or smoothr for navigation.)
              - adcpsect           (1) # these three must be run anyway for
              - refabs             (2) #     reflayer diagnostic plots and
              - smoothr            (3) #     watertracking or recip to work)
              - refsm                  # for navigation, if specified
              - plot reference layer 
              - putnav;                # from specified (refsm, smoothr)
  "calib"     - watertrack
              - bottom track
  "matfiles"   
               - timegrid (for standardized matlab files)
               - standardized matlab vector and contour files


after editing, apply editing to database:
  "apply_edit" - applies ascii files edit/*.asc to database
  "navsteps", calib, matfiels (as above)



Notes:

 1) Run quick_adcp.py in one window, with another for investigating
    problems.  Be sure to check the output of scan before trying to load,
    in case there  are problems with timestamps.

 2) For data other than pingdata, quick_adcp.py will run matlab to create
    intermediate files that are then loaded into the database (*.cmd and *.bin).
    The navigation file is created by catting the ".gps1" files from the
    load/ subdirectory (after ldcodas has been run).  In this case the nav file
    has a .gps  suffix. Otherwise, the nav file comes from ubprint and has a ".ags"
    suffix.

 3) If processing single-ping data (ENS, ENX, or UHDAS):
    ---> DO NOT DELETE the BLKINFO.txt file or blkinfo.mat <---
    in the load/ directory.

 4) running quick_adcp.py more than once:
    a) after a single-pass load of the data, you may want to apply editing,
       run the navigation steps, apply a rotation, rerun the calibration
       steps,  or make new matlab files.  use "steps2rerun"
    b) if you are at sea and want to run quick_adcp.py once a day to
       incorporate  the new data, use --lastfiles (not well-documented yet)

 '''
   print str

#--- end print_overview --------------------------------------------------


def  print_howto_lta():

   str = '''

This will have a quick LTA example
'''
   print str

#---------------------

def  print_howto_ping():

   str = '''

(0) If you are running MSWindows, you run a .BAT files called quickadcp_py
     to set paths and get around commandline length limit.  See
     adcp_processing.html (created  by adcptree_py) for more details.

(1) Determine your processing location, create the processing directory:

         "adcptree.py vg0404"

(2) Copy (or link) the pingdata files to the ping/ subdirectory

(3) in the processing directory, run:

    quick_adcp.py --dbname a0404 --yearbase 2004 --use_refsm


    explanation:
    * "--yearbase" is specified so the decimal days come out correctly
    * "--use_refsm" specifies that smoothed navigtion will come from the
          "refsm.sm" file as opposed to ademo.sm (which comes from smoothr).
          You must specify one type of navigation.  All the old nav steps get
          run anyway because we still need them for the reference layer
          diagnostic plots and for watertrack calibration.

    ### defaults are equievalent to the following control file:
    --rl_startbin 2
    --rl_endbin   20
    --datadir ping
    --datafile_glob pingdata.*   ## you could change this to PINGDATA.*
    --pgmin 50
    --rotate_angle 0.0
    --rotate_amp 1.0
    #### end of cntfile description

   it asks                            you say             why
    -------------                    -------------        ------
scan pingdata data now?                  y      scan the ping files,
                                                - create scan/a0404.scn
                                                - create scan/a0404.tr


load pingdata now?                       y      load the pingdata into
                                                  the database


make a new pre-configured setup.m ?      y      makes edit/asetup.m and
                                                  edit/aflagit_setup.m
                                                  for gautoedit editing


run setflags?                            y      sets profile flags
                                                  for pg minimum

                                                  
run ubprint?                             y       making .ags (position)
                                                   file, also extracts
                                                   ashtech heading file
                                                   (nav/a0404.mat)

run ashrot?                              y       makes ashtech (ash-gyro)
                                                   file in cal/rotate
                                                         

write ashtech statistics log file?       y       
                                                 
run rotate?                              y       apply a0404.ang, logfile:
                                                  cal/rotate/rotate.log
                                                  (amp=1.0, phase=0.0)
                                                 
run adcpsect?                            y       making .nav file
                                                  (used for watertrack
                                                  and reflayer plots)
                                                 
                                                 
run refabs?                              y       making .ref file
                                                  (used for watertrack
                                                  and reflayer plots)
                                                 
                                                 
run smoothr?                             y       make .sm file
                                                  (used for watertrack
                                                   and reflayer plots)
                                                 
                                                 
run refsm for smoothed navigation?       y       make nav/refsm.sm for
                                                   putnav
                                                 
                                                 
run putnav?                              y        put refsm.sm navigation
                                                    into database
                                                 
make reference layer plots?              y        make reference layer
                                                    plots.
                                                    
                                                 
run lst_temp?                            y        list temperature,
                                                    make plot (in edit/)
                                                 
run botmtrack and watertrack calibrations? y      Do  water track
                                                   calibration (uses 7
                                                   fixes) and bottom
                                                   track calibration
                                                   ( step size of 1)
                                                 
make matlab files for plotting?          y        runs adcpsect, makes
                                                    (50m bins, 60min)
                                                    averages in vector/
                                                    (10m bins, 15min)
                                                    averages in contour/



NOTES:
=======

... and then it\'s done.  Now go look over what has happened: a log of
steps run by quick_adcp.py is left in vg0404/vg0404.runlog.  

Check the watertrack and bottom track calibration values, adjust accordingly.
Edit the data (in edit, fire up matlab and run 'gautoedit')
Apply the editing.
(see \'quick_adcp.py --commands pingdata\' for more details)



'''
   print str

#--- end print_howto_ping--------------------------------------------------

def print_vardoc():
   str = '''
- - - - - - - - - - - - - - - - - - - - - - - - - - - -- - - - - - - - - - - 

These are relevant to any codas processing of shipboard ADCP data


Options are specified on the command line or in a file.  (see below)

           === directories and files ===

 variable         default     # description
 -------       ----------     -----------------
                           
cntfile            None    # override defaults with values from this
                           #   control file.  Format is the same as
                           #   command line options, but whitespace is
                           #   unimportant.  Do not quote wildcard
                           #   characters in the cnt file (whereas
                           #   you would for the command line)
                           # Defaults are overridden by this cntfile
                           # Commandline options can override either.
                           
                           
cruisename        (cwd)    # title name only
procdir           (cwd)    # processing direcory -- same as 
                           #     2nd argument of adcptree.py)
                           
datadir       \'../ping\'  # data path relative to scan or load directory
                           #     (1) relative to scan or load directory
                           #     (2) full path
                           #  ../ping           (for LTA, ENS, pingdata)
                           #  uhdas_dirbase/raw/instname (for uhdas)
                           
progdir           \'\'     #where to find the programs (automatic detection)
binos           \'lnx\'    #subdirectory name  with executables
                           
datafile_glob \'PINGDATA.???\'#look for sequential pingdata files
                           #  pingdata.???  (for pingdata)
                           #  *.LTA         (for LTA files)
                           #  *.ENS         (for ENS files)
                           #  *.raw         (for uhdas)
                           
  ### these three do not have useful defaults and are REQUIRED for use
                           
dbname           None      # limit 5 characters, start with "a"
                           #   then append  4 characters
                           # Required for loading a database, but not
                           #   for "steps2rerun"
                          
yearbase         None      # 4 digits (always required)
                           
                           ##  choose one or the other for smoothed nav
use_refsm        0         # use refsm for smoothed navigation
use_smoothr      0         # use smoothr for smoothed navigation

log_yearbase   None        # 4 digits (for hdss data only; try 2003)

                           
           === instrument configuration ===
 variable         default     # description
 -------       ----------     -----------------
                           
instname         nb150     # instrument type + frequency: describes instrument
                           # used for (1) UHDAS (required: determines configuration)
                           #          (2) to choose matlab output depth ranges
                           #               (any run)
                           # Default is "nb150"
                           #      choose from:
                           #      os75, os38    (phased array "ocean surveyor")
                           #      nb150         (narrowband instrument)
                           #      bb            (broadband instrument)
                           
pingtype          nb       #  only required for instrument "os"
                           #   using uhdas (then choose "nb" or "bb")
                           #  For all others, only one pingtype is
                           #     possible ( therefore pingtype defaults
                           #     to instrument type)
                           
datatype       \'pingdata\'      
                           # choose what kind of data logging (and
                           #   hence which kind of data files 
                           #   are being processed)
                           #
                           # default is "pingdata"
                           #
                           #  name          what
                           #  ----          ----
                           #  "pingdata"     implies DAS2.48 (or 2.49) NB
                           #                     data, already averaged
                           #  "uhdas"        implies known directory 
                           #                     structure for access
                           #                     to raw data
                           #  "lta", "sta"   VmDAS averages
                           #  "enx"          implies VmDAS single-ping
                           #                     data,time-corrected,
                           #                     navigated with attitude
                           #  "hdss"         HDSS (Revelle); unsupported code
                           
                           
                           
ub_type        \'1920\'      # For NB DAS only: User buffer type:
                           # 720 for demo, usually 1920 for recent cruises
                           
ens_len         300        # seconds in an averaged profile
                           
numbins          60        # number of bins to use with editing
                           # (60 is a good guess)
                           
firstdepth       25        # shallowest depth bin: used for matlab calculations
                           
           === processing options ===
                           
 variable         default     # description
 -------       ----------     -----------------

                           
rotate_amplitude  1        # start with 1.0 for amp and 0.0 for phase
rotate_angle      0        # Applied along with gyro minus gps.
                           # (\'phase\' from watertrk or btmtrk calib)
                           # ONLY used with pingdata or LTA files
                           
rotate_file     ''         # transducer offset in a file, eg. ash-gyro
                           #    (file must already exist at the time
                           #        "rotate" is run)
                           # REQUIRES one angle correction per ensemble
                           #     with the correct times for ensembles
                           # (untested)
                           
rl_startbin       2        # first bin for reference layer
rl_endbin        20        # last bin for reference layer
                           
pgmin          (varies     # only accept PG greater than this value
                with       # --> don\'t go below 30 <--
                datatype)  # default is 50 for datatypes \'pingdata\',
                           # \'bblta\', and \'oslta\'
                           ### (default is 20 for manually averaged ###
                           ### single ping data, nbuh and sonuh) ###
                           

hcorr_inst  = \'ashrot\'   # This is for pingdata.
                           # FOR UHDAS, need to specify instrument and method
                           #   set to 'ashtech', 'posmv', 'seapath', 'gyro'
                           #       ('gyro' effectively disables)
                           #       (uses cal/rotate/hcorr.ang)
                           #   To apply the heading correction, choose method:
                           #       --ping_headcorr (or)  --post_headcorr
                           # see further web-based documentation for more details
                                   
ping_headcorr   =  0       # Choose at most one of these methods
post_headcorr   =  0       #    to apply the heading correction
                           # NOTE: a heading correction will only occur
                           #      if there is a proper device available and
                           #      if one of these two methods is chosen.

num_persistence = 24       # attempt to use good heading corrections from     
                           #     previous N heading corrections.              
                           #  -  persistence will be attempted                
                           #      - if num_persistence > 0                    
                           #      - if ping_headcorr was chosen               
                           #  - if post_headcorr, the ens_hcorr files are     
                           #      still generated, but are not applied to the 
                           #      data.  See html documentation under UHDAS   


                           
fixfile          None      # override the default fix file.  defaults are:
                           # if datatype is pingdata, default is [dbname].ags
                           # otherwise default is [dbname].gps
                           
                           
                           
           === REPROCESSING options ===
                           
                           
 variable         default     # description
 -------       ----------     -----------------
                           #
                           # Once quick_adcp.py has been run, reprocessing
                           # steps can be run by specifying --steps2rerun
                           # with the following options.  Try 
                           # "quick_adcp.py --usage" for details
                           #
steps2rerun                # colon-separated list of the following:
                           # \'apply_edit:navsteps:calib:matfiles\', designed
                           # for batch mode; assumes codasdb already in
                           # place, operates on entire database.
                           #
                           # \'navsteps\' is:
                           #   [adcpsect+refabs+smoothr or refsm], putnav
                           # \'apply_edit\' is:
                           #   badbin, dbupdate, set_lgb, setflags
                           # \'calib\' is:
                           #   botmtrk (refabsbt, btcaluv)
                           #   watertrk (adcpsect, timslip, adcpcal)
                           # \'matfiles\' is:
                           #   adcpsect for vector and contour
                           
           === specialized processing options  ===
                           
                           
 variable         default     # description
 -------       ----------     -----------------
                           
                           #
auto             0         # 1: whiz along (do not prompt); do all
                           #    requested steps (default is all step)
                           #    0 to prompt at each step
find_pflags      0         #  automatically find profile flags (run autoedit)
                           #  and apply editing (dbupdate, etc)
                           #  For use with automatic incremental logging and
                           #    processing of data, eg N.B.Palmer
                           #
                           
                           
           ===  raw processing, ENS or ENX files from VmDAS ===
 variable         default     # description
 -------       ----------     -----------------
                           
enddday_file   [file]      # copy this file to the load directory and use
                           # its times as ensemble end-times.  (eg. align
                           # times with a the same cruise processed
                           # with pingdata).     
                           
ducer_depth      -1        # add this to measured depth bins to correct
                           # transducer depth: ONLY used with single-ping
                           # data 
                           
                           
ens_halign    \'None\'     # for ENS processing only, conversion from
                           # beam to earth coordinates: need to
                           # specify transducer alignment -- REQUIRED
                           # (ENX files are already in earth coordinates)
                           # (see \'rotate_angle\' and \'rotate_file\'
                           #    for rotation of codas database
                           #    as part of calibration steps
                           
                           
lastfiles [integer]        # incremental processing: delete the last (few)
                           # blockfiles and (average and) load all
                           # data after the remaining database.
                           # NOTE: for LTA and pingdata, \'lastfiles\'
                           # refers to number of data files.
                           # (use "--commands lastfile" for more info)
                           # NOTE "--lastfiles 1" MAY work for:
                           #      pingdata, LTA, STA
                           # untested of late



           === raw processing, UHDAS only ===
                           
 variable         default     # description
 -------       ----------     -----------------
                           
                           
cfgbase        [string]    #  raw logging path and config information here.
                           # files are [cfgbase]_cfg.m, [cfgbase]_proc.m,
                           # and [cfgbase]_disp.m, located in cfgpath
                           
cfgpath        [path]      # get raw logging path information here.
                           # For uhdas, adcptree.py makes a
                           # directory "config" and populates it with
                           # copies of existing files (cfgbase_*.m)
                           # or templates.  Edit as needed BEFORE running
                           # quick_adcp.py
                           
instclass         'unset'  # instrument category (UHDAS only)
                           #       Default is "nb"
                           #      choose from:
                           #      os    (phased array "ocean surveyor")
                           #      bb    (broadband instrument)
                           #      nb    (narrowband instrument)
                           
tktail           0         # put up a scrolling window when averaginv UHDAS raw
                           #     data (must have Tkinter installed; )
                           
                           
                           
delblks          []        # for incremental processing of UHDAS data:
                           # delete this nnumber of blocks from the database.
                           # Averaging will continue with whatever is not
                           # yet averaged.  Reload unloaded ens_blk*.cmd files.
                           # usual usage: --delblks 1  (standard incremental)
                           # debugging only: --delblks 0 (WILL reload all)
                           
timeout_secs     86400     # For batch processing, disable
                           #        (set large) the timeout.
                           # for underway (incremental) processing,
                           #         set to 1000

                            
max_BLKprofiles  399       # max number of profiles per block.  Might
                           #  want to make smaller to test incremental
                           #  processing (must be 399 or less)
                           

update_gbin         0      # batch mode, UHDAS; update gbin files

             === raw processing, UHDAS only, incremental ===

hidedisplay      0         # show figures as they are made (turn off
                           # to run from a script with cron on a ship

dday_bailout        ''     # may be useful for testing 
                           #   (bail out of averaging at this time)

editcfg_file 'override_editcfg'
                           # run this program to override editcfg defaults
                           # (single ping editing; for section-based editing)
                           # (full path, or copy to load/ and use relative
                           # 


hcorr_inst  = \'gyro\'     # FOR UHDAS, need to specify instrument and method
                           #   set to 'ashtech', 'posmv', 'seapath', 'gyro'
                           #       ('gyro' effectively disables)
                           #       (uses cal/rotate/hcorr.ang)
                           #   To apply the heading correction, choose method:
                           #       --ping_headcorr (or)  --post_headcorr
                           # see further web-based documentation for more details
                                   
ping_headcorr   =  0       # Choose at most one of these methods
post_headcorr   =  0       #    to apply the heading correction

                                    

save_lastens         0     # save average and raw data from last 5-minute
                           # ensemble as "lastens.mat"  (for underway
                           # access to lastens).  Slows down progress
                           ## (usually implimented through run_lastensq.py)
                                    
nosave_editcfg      0      # usually write editcfg parameters to a log file
                           # Turn this on to avoid saving, if incremental
                           # processing, to avoid excessively large log files

skip_avg            0      # underway UHDAS processing: 5-minute averages
                           # are done by an outside source. results:
                           #  (1) scan only first and last file
                           #  (2) skip write_ensblk.m; go straight to ldcodas


 -------       ----------     -----------------
 variable         default     # description   (SEE PREVIOUS TEXT)
-----------------------------------------------------------------------------

NOTE: files can be identified in two ways:
  (1) file names after all the switches must be explicit files with path
      names correct as seen from the load/ or scan/ direcories.
      Fully qualified filenames will work
  (2) See note above about datadir and datafile_glob usage
  
usage depends on data type.  try these for help:

(unix:)                                 # Simple example for:
                                        # -------------------
quick_adcp.py --commands  LTA           #  LTA or STA files
quick_adcp.py --commands  ENX           #  ENX or ENS files
quick_adcp.py --commands  UHDAS         #  UHDAS files
quick_adcp.py --commands  pingdata      #  pingdata files
quick_adcp.py --commands  lastfiles     #  at-sea processing ("incremental")

(Windows):
NOTE to Windows users: replace 'quick_adcp.py' with 'quickadcp_py' and
                       replace 'adcptree.py' with 'adcptree_py'.  These
                       are .BAT files that set enviromennt variables and
                       call the respective python versions.


in general,...
quick_adcp.py --yearbase num --dbname axxxx \\
   [--use_refsm | --use_smoothr] \\
  --datatype [pingdata | lta | sta | ens | enx | uhdas] \\
  --pingtype [nb | bb | son] \\
  --instclass [os | nb | sbb | son] \\
  [--datadir dirname --datafile_glob "quoted_expression"] file1 [file2 ...]



'''
   print str
