/******************************************************************************

    FILE:  DATA_ID.H

           This file contains standard names and IDs for most of the common
           user-defined variables loaded in a CODAS database.

******************************************************************************/

#ifndef data_id_included
#define data_id_included

#define DEPTH                    0
#define TEMPERATURE              1
#define SALINITY                 2
#define OXYGEN                   3
#define OPTICS                   6
#define AMP_SOUND_SCAT           7
#define U                        8
#define V                        9
#define P                       10
#define TEMP_SAMPLE             11
#define SALINITY_SAMPLE         12
#define OXYGEN_SAMPLE           13
#define NUTRIENT_SAMPLE         14
#define TRACER_SAMPLE           15
#define OCEAN_DEPTH             20
#define WEATHER                 21
#define SEA_SURFACE             22
#define PROFILE_COMMENTS        32
#define BLOCK_COMMENTS          33
#define PROFILE_FLAGS           34
#define CONFIGURATION_1         35
#define CONFIGURATION_2         36
#define ANCILLARY_1             37
#define ANCILLARY_2             38
#define ACCESS_VARIABLES        39
#define DEPTH_SAMPLE            40
#define SIGMA_T                 41
#define SIGMA_THETA             42
#define SIGMA_Z                 43
#define SIGMA_2                 44
#define SIGMA_4                 45
#define SPEC_VOL_ANOM           46
#define THERMOSTERIC_ANOM       47
#define DYNAMIC_HEIGHT          48
#define BVF                     49
#define SOUNDSPEED              50
#define TIME_FROM_START         51
#define POTENTIAL_TEMP          52
#define CONDUCTIVITY            53
#define W                       54
#define ERROR_VEL               55
#define PERCENT_GOOD            56
#define PERCENT_3_BEAM          57
#define SPECTRAL_WIDTH          58
#define U_STD_DEV               59
#define V_STD_DEV               60
#define W_STD_DEV               61
#define EV_STD_DEV              62
#define AMP_STD_DEV             63
#define RAW_DOPPLER             64
#define RAW_AMP                 65
#define RAW_SPECTRAL_WIDTH      66
#define BEAM_STATS              67
#define NAVIGATION              68
#define BOTTOM_TRACK            69
#define U_LOG                   70
#define V_LOG                   71
#define USER_BUFFER             75
#define ADCP_CTD                76
#define CORRELATION_MAG         77

#endif
