/* 

      FILE:  DATA_LST.H

      This file declares and initializes an array of structures
      with data names and IDs.  It is used for converting 
      names into codes, or vise-versa.
      Only those data types that are likely to be arrays, 
      and might therefore be surveyed using PROFSTAT are 
      included here.  For other purposes, a more complete, 
      or a more restricted, list might be appropriate.

      This sort of list must have a null pointer at the end.

*/

#ifndef data_lst_included
#define data_lst_included
#ifndef data_id_included
#include "data_id.h"    /* U, V, etc. */
#endif
#ifndef dbext_included
#include "dbext.h"      /* NAME_LIST_ENTRY_TYPE */
#endif

NAME_LIST_ENTRY_TYPE data_type_list[] =
{
   {"U", U},
   {"V", V},
   {"TEMPERATURE", TEMPERATURE},
   {"SALINITY", SALINITY},
   {"OXYGEN", OXYGEN},
   {"AMP_SOUND_SCAT", AMP_SOUND_SCAT},
   {"P", P},
   {"SIGMA_T", SIGMA_T},
   {"SIGMA_THETA", SIGMA_THETA},
   {"SIGMA_Z", SIGMA_Z},
   {"SIGMA_2", SIGMA_2},
   {"SIGMA_4", SIGMA_4},
   {"SPEC_VOL_ANOM", SPEC_VOL_ANOM},
   {"THERMOSTERIC_ANOM", THERMOSTERIC_ANOM},
   {"DYNAMIC_HEIGHT", DYNAMIC_HEIGHT},
   {"BVF", BVF},
   {"SOUNDSPEED", SOUNDSPEED},
   {"POTENTIAL_TEMP", POTENTIAL_TEMP},
   {"CONDUCTIVITY", CONDUCTIVITY},
   {"W", W},
   {"ERROR_VEL", ERROR_VEL},
   {"PERCENT_GOOD", PERCENT_GOOD},
   {"PERCENT_3_BEAM", PERCENT_3_BEAM},
   {"BEAM_STATS", BEAM_STATS},
   {"SPECTRAL_WIDTH", SPECTRAL_WIDTH},
   {"U_STD_DEV", U_STD_DEV},
   {"V_STD_DEV", V_STD_DEV},
   {"W_STD_DEV", W_STD_DEV},
   {"EV_STD_DEV", EV_STD_DEV},
   {"AMP_STD_DEV", AMP_STD_DEV},
   {"RAW_DOPPLER", RAW_DOPPLER},
   {"RAW_AMP", RAW_AMP},
   {"RAW_SPECTRAL_WIDTH", RAW_SPECTRAL_WIDTH},
   {"CORRELATION_MAG", CORRELATION_MAG},
   {"DEPTH", DEPTH},
   {NULL, 0}
};

#endif

