/*****************************************************************************
*                                                                            *
*      COMMON OCEANOGRAPHIC DATA ACCESS SYSTEM (CODAS)                       *
*                                                                            *
*      WRITTEN BY:  RAMON CABRERA, ERIC FIRING, and JULIE RANADA             *
*                   JOINT INSTITUTE FOR MARINE AND ATMOSPHERIC RESEARCH      *
*                   1000 POPE ROAD  MSB 404                                  *
*                   HONOLULU, HI 96822                                       *
*                                                                            *
*      VERSION:     3.00                                                     *
*                                                                            *
*      DATE:        APRIL 1989                                               *
*                                                                            *
*****************************************************************************/
/*

       FILE:  find_def.h

              Function used to find a structure definition from some list.

*/
#ifndef find_def_included
#define find_def_included

#ifndef dbhost_included
#include "dbhost.h"        /* PROTOTYPE_ALLOWED */
#endif

#ifndef dbext_included
#include "dbext.h"         /* STRUCT_DEF_HDR_TYPE, STRUCT_DEF_ELEM_TYPE */
#endif

#if PROTOTYPE_ALLOWED
STRUCT_DEF_HDR_TYPE *find_def(char *struct_name, STRUCT_DEF_HDR_TYPE *str_def);
int find_elem(char *elem_name, char *struct_name,
   STRUCT_DEF_HDR_TYPE *linked_list, unsigned int *data_ofs, unsigned int *nb,
   STRUCT_DEF_ELEM_TYPE *elem_def);
long get_struct_size(char *struct_name, STRUCT_DEF_HDR_TYPE *linked_list);
long get_elem_size(STRUCT_DEF_ELEM_TYPE *elem_def,
   STRUCT_DEF_HDR_TYPE *linked_list);
#else
STRUCT_DEF_HDR_TYPE *find_def();
int find_elem();
long get_struct_size();
long get_elem_size();
#endif

#endif /* ifndef find_def_included */

