/*****************************************************************************
*                                                                            *
*      COMMON OCEANOGRAPHIC DATA ACCESS SYSTEM (CODAS)                       *
*                                                                            *
*      WRITTEN BY:  RAMON CABRERA                                            *
*                   JOINT INSTITUTE FOR MARINE AND ATMOSPHERIC RESEARCH      *
*                   1000 POPE ROAD  MSB 414                                  *
*                   HONOLULU, HI 96822                                       *
*                                                                            *
*      VERSION:     3.00                                                     *
*                                                                            *
*      DATE:        APRIL 1989                                               *
*                                                                            *
*****************************************************************************/
/*

    FILE:  GENINC.H

           A generally useful #include header file for CODAS source routines.
           It #defines host environment parameters,
           #includes standard header files needed by specific compilers, and
           #includes the standard CODAS header files "dbext.h" and "db.dcl".

           Any program that uses CODAS routines must #include this
           file.  It must also take care NOT to #include any standard
           C header files that are already #included here, e.g.,
           <stdio.h>.  See below for a complete listing.

           To use this file, make sure the host environment parameters
           are appropriately #defined for your system.

*/

#ifndef geninc_included
#define geninc_included

#ifndef dbhost_included
#include "dbhost.h"                   /* COMPILER */
#endif

#ifndef common_included
#include "common.h"                   /* commonly used header files */
#endif

#if (COMPILER == TURBO_C)
#include <dos.h>                      /* unlink function */
#endif

/*
       DATABASE SYSTEM'S INCLUDE FILES
*/
#ifndef dbext_included
#include "dbext.h"
#endif

#ifndef dbdcl_included
#include "dbdcl.h"
#endif

#endif /* ifndef geninc_included */
