/*****************************************************************************
*                                                                            *
*      COMMON OCEANOGRAPHIC DATA ACCESS SYSTEM (CODAS)                       *
*                                                                            *
*      WRITTEN BY:  RAMON CABRERA, ERIC FIRING, and JULIE RANADA             *
*                   JOINT INSTITUTE FOR MARINE AND ATMOSPHERIC RESEARCH      *
*                   1000 POPE ROAD  MSB 404                                  *
*                   HONOLULU, HI 96822                                       *
*                                                                            *
*      VERSION:     3.00                                                     *
*                                                                            *
*      DATE:        APRIL 1989                                               *
*                                                                            *
*****************************************************************************/
/*

    FILE:  mem_.h

           Memory access functions.

*/
#ifndef mem__included
#define mem__included

#ifndef dbhost_included
#include "dbhost.h"        /* PROTOTYPE_ALLOWED */
#endif
#ifndef dbext_included
#include "dbext.h"         /* LONG, etc. */
#endif

#if PROTOTYPE_ALLOWED
void set_long   (LONG *lbuff, LONG l_mask, unsigned int nv);
void set_short  (USHORT *sbuff, USHORT s_mask, unsigned int nv);
void set_byte   (UBYTE *bbuff, UBYTE b_mask, unsigned int nb);
void move_byte  (CHAR *bbuff1, CHAR *bbuff2, unsigned int nv);
void move_short (SHORT *sbuff1, SHORT *sbuff2, unsigned int nv);
void move_long  (LONG *lbuff1, LONG *lbuff2, unsigned int nv);
int cmp_byte    (char *buf1, char *buf2, unsigned int nb);
void break_short(USHORT *twobyte, UBYTE *upbyte, UBYTE *lobyte, unsigned int nv);
#else
void set_long();
void set_short();
void set_byte();
void move_byte();
void move_short();
void move_long();
int cmp_byte();
void break_short();
#endif

#endif /* ifndef mem__included */

