/*****************************************************************************
*                                                                            *
*      COMMON OCEANOGRAPHIC DATA ACCESS SYSTEM (CODAS)                       *
*                                                                            *
*      WRITTEN BY:  RAMON CABRERA, ERIC FIRING, and JULIE RANADA             *
*                   JOINT INSTITUTE FOR MARINE AND ATMOSPHERIC RESEARCH      *
*                   1000 POPE ROAD  MSB 404                                  *
*                   HONOLULU, HI 96822                                       *
*                                                                            *
*      VERSION:     3.00                                                     *
*                                                                            *
*      DATE:        APRIL 1989                                               *
*                                                                            *
*****************************************************************************/
/*-----------------------------------------------------------------------------

       FILE:  misc.h

              MISCELLANEOUS FUNCTIONS

*/
#ifndef misc_included
#  define misc_included
#  ifndef dbhost_included
#     include "dbhost.h"         /* PROTOTYPE_ALLOWED, COMPILER */
#  endif

#  ifndef dbext_included
#     include "dbext.h"          /* BADINT */
#  endif

typedef struct
{
   char *name;
   int code;
} NAME_LIST_ENTRY_TYPE;

#  if PROTOTYPE_ALLOWED
      void strtrim          (char *s2, char *s1, int n);
      void split_path       (char *all, char *path, char *name);
      int get_code          (NAME_LIST_ENTRY_TYPE *list, char *name);
      char *get_name        (NAME_LIST_ENTRY_TYPE *list, int code);
#     ifdef LACKS_STRICMP
         int stricmp           (char *str1, char *str2);
#     endif

#  else
      void strtrim();
      void split_path();
      int get_code();
      char *get_name();
#     ifdef LACKS_STRICMP
         int stricmp();
#     endif
#  endif


#endif /* ifndef misc_included */
