/*
   FILE:  PROFMASK.H

   This file defines bit masks for an unsigned byte.  It is used to specify
   options on which bits of the PROFILE_FLAG to use as criteria in
   flagging profile data.

*/

#ifndef profmask_included
#define profmask_included
#ifndef misc_included
#include "misc.h"             /* NAME_LIST_ENTRY_TYPE */
#endif

#define BIT_0    0x01  /* 00000001 */
#define BIT_1    0x02  /* 00000010 */
#define BIT_2    0x04  /* 00000100 */
#define BIT_3    0x08  /* 00001000 */
#define BIT_4    0x10  /* 00010000 */
#define BIT_5    0x20  /* 00100000 */
#define BIT_6    0x40  /* 01000000 */
#define BIT_7    0x80  /* 10000000 */
#define ALL_BITS 0xFF  /* 11111111 */
#define NO_BITS  0x00  /* 00000000 */

NAME_LIST_ENTRY_TYPE profmask_list[] =
{
   {"BIT_0",    0x01},  /* 00000001 */
   {"BIT_1",    0x02},  /* 00000010 */
   {"BIT_2",    0x04},  /* 00000100 */
   {"BIT_3",    0x08},  /* 00001000 */
   {"BIT_4",    0x10},  /* 00010000 */
   {"BIT_5",    0x20},  /* 00100000 */
   {"BIT_6",    0x40},  /* 01000000 */
   {"BIT_7",    0x80},  /* 10000000 */
   {"ALL_BITS", 0xFF},  /* 11111111 */
   {"NO_BITS",  0x00},  /* 00000000 */
   {NULL,         0 }
};

#endif /* ifndef profmask_included */

