/*

      FILE:  VALUE_LST.H

      This file declares and initializes an array of structures
      with value names and IDs.  It is used for converting
      names into codes, or vise-versa, by defstruc.c, and by
      user-level routines.

      This sort of list must have a null pointer at the end.

*/

#ifndef value_lst_included
#define value_lst_included

#ifndef dbext_included
#include <dbext.h>      /* NAME_LIST_ENTRY_TYPE and VALUE defines */
#endif

/*
       CODES OF VALUE TYPES IN NAME_LIST_ENTRY_STRUCTURE FORM
*/
NAME_LIST_ENTRY_TYPE VALUE_CODE[] =
{
   {"BYTE"   ,  BYTE_VALUE_CODE},
   {"UBYTE"  ,  UBYTE_VALUE_CODE},
   {"CHAR"   ,  CHAR_VALUE_CODE},
   {"SHORT"  ,  SHORT_VALUE_CODE},
   {"USHORT" ,  USHORT_VALUE_CODE},
   {"LONG"   ,  LONG_VALUE_CODE},
   {"ULONG"  ,  ULONG_VALUE_CODE},
   {"FLOAT"  ,  FLOAT_VALUE_CODE},
   {"DOUBLE" ,  DOUBLE_VALUE_CODE},
   {"COMPLEX",  COMPLEX_VALUE_CODE},
   {"TEXT"   ,  TEXT_VALUE_CODE},
   {"STRUCT" ,  STRUCT_VALUE_CODE},
   {NULL     ,  0}           /* list terminator */
};


#endif
