
''' Read and write flat ascii numeric files.

    This might be extended to handle comment lines, etc,
    but at present it is a minimal version.
    (Right now: a *very* minimal read iterator,
    with no write support.)
'''

class ascfile:
   def __init__(self, filename, mode = 'r', ncolumns = 0):
      self.file = file(filename, mode)
      self.ncolumns = ncolumns
      self.filename = filename
      if mode[0] != 'r':
         assert ncolumns > 0
      if ncolumns == 0:
         ncolumns = len(self.file.readline().split())
         self.file.seek(0)
      if mode[0] == 'r':
         self.lines = self.file.readlines()
      self.cursor = 0

   def __iter__(self):
      return self

   def __del__(self):
      if self.file:
         self.file.close()

   def close(self):
      self.file.close()
      self.file = None

   def next(self):
      self.lines += self.file.readlines()
      if self.cursor >= len(self.lines):
         raise StopIteration
      line = self.lines[self.cursor]
      self.cursor += 1
      return [float(f) for f in line.split()]

   def seek(self, index, whence=0):
      self.lines += self.file.readlines()
      nrec = len(self.lines)
      if whence == 0:
         irec = index
      elif whence == 1:
         irec = self.cursor + index
      elif whence == 2:
         if index > 0:
            raise IndexError
         irec = nrec + index
      else:
         raise ValueError
      irec = min(irec, nrec)
      irec = max(irec, 0)
      self.cursor = irec


