
''' Binfile class for numpy.
'''

import numpy as N
from binfile import binfile_s

class binfile_n(binfile_s):
    def __init__(self, *args, **kwargs):
        "%s" % binfile_s.__init__.__doc__
        binfile_s.__init__(self, *args, **kwargs)

    def read_n(self, n=None):
        s, n = binfile_s.read_n(self, n)
        dtype = '%s%s' % (self.byteorder, self.type)
        a = N.fromstring(s, dtype=dtype, count = n * self.ncolumns)
        a.shape = (n, self.ncolumns)
        a = N.asarray(a, dtype = self.type) # ensure native byteorder
        return a, n

    def write(self, a):
        s = N.asarray(a, dtype = self.type).tostring()
        nrec = binfile_s.write(self, s)
        return nrec

