#!/usr/bin/env python

import time
import incr_class
import os
import serasc2bin
import glob

yearbase = 2003
dir_asc_base = '/home/data/adcp/raw'
dir_bin_base = '/home/adcp/adcpr/rbin'

#subdir_messages =  {'adu2': ('gps', 'adu'),
#            'gyro': ('hdg',),
#            'pcode': ('gps',),
#            'posmv': ('gps', 'pmv')}

subdir_messages =  {'gyro': ('hdg',),
                    'pcode': ('gps',)}



comment = '''
for subdir in subdir_messages.keys():
   A = serasc2bin.asc2bin(yearbase = yearbase, showbad = 1,
                           outfiledir = os.path.join(dir_bin_base, subdir),
                           )
   for msg in subdir_messages[subdir]:
      files = glob.glob(os.path.join(dir_asc_base, subdir, 'rb*'))
      A.translate_files(files, message = msg)
''' # end comment



T = incr_class.Translate(dir_asc_base = dir_asc_base,
                         dir_bin_base = dir_bin_base,
                         yearbase = yearbase,
                         # gzip = 1, # Doesn't work; have two threads
                         redo = 0,      # reading the same file.
                         showbad = 1,
                         sleepseconds = 1,
                         maxsleeps = 5,
                         subdir_messages = subdir_messages)



T.start()
while T.running:
   try:
      time.sleep(1)
   except:  # Ctl-C
      T.stop()

