#!/usr/bin/python

## JH - simple script using os.system() to run serasc2bin.py
## (see batchbin.py to use serasc2bin.py from inside python)


import os, sys, shutil, pwd, string

startdir = '/home/data'
os.chdir(startdir)

   

# dirlist  = ('np0401',) 


# instlist = ('ashtech', 'gpsnav',  'seapath', 'sndspd', 'gyro')
# msglist = {}      ## initialize
# msglist['ashtech']    = ('gps', 'adu')
# msglist['gpsnav']   = ('gps',)
# msglist['seapath'] = ('gps_sea', 'sea')
# msglist['gyro']    = ('hdg',)
# msglist['sndspd']  = ('spd',)


dirlist  = ('drydock_osnb',) 
yearbase = '2004'
log_yearbase = yearbase
gunzip = 1
gzip = 1




instlist = ('ashtech', 'gpsnav', 'sndspd', 'gyro', 'seapath')
msglist = {}      ## initialize
msglist['ashtech']    = ('gps', 'adu')
msglist['gpsnav']   = ('gps',)
msglist['seapath'] = ('gps_sea', 'sea')
msglist['gyro']    = ('hdg',)
msglist['sndspd']  = ('spd',)


for diri in range(0,len(dirlist)):

   dir = dirlist[diri]
   
   rbinbase =  '%s/rbin' % (dir)
   print 'yearbase is ', yearbase
   print 'rbinbase is %s' % (rbinbase)
   if os.path.exists(rbinbase):
      print 'not making ', rbinbase
   else:
      print 'making ', rbinbase
      os.mkdir(rbinbase)

   

   for instrument in instlist:
      indir = os.path.join(dir, 'raw', instrument)
      outdir = os.path.join(rbinbase, instrument)
      if os.path.exists(indir):
         print 'getting files from ', indir
   
         
         if os.path.exists(outdir):
            print 'not making ', outdir
         else:
            print 'making ', outdir
            os.mkdir(outdir)

         if gunzip == 1:
         ## gunzip first
            cmd = 'gunzip %s/*.gz' %  (indir)
            print 'about to run: \n', cmd
            os.system(cmd)

         for msg in msglist[instrument]:
            print 'message is ', msg
            cmd = 'serasc2bin.py -r -l %s -y %s -m %s -t uhdas -o %s %s/*' % \
                  (log_yearbase, yearbase, msg, outdir, indir)
            print 'about to run: \n', cmd
            os.system(cmd)


            if gzip == 1:
         ## gzip after
               cmd = 'gzip %s/*' %  (indir)
               print 'about to run: \n', cmd
               os.system(cmd)

      else:
         print 'no such directory: ', indir
            
         
      
