import time
import incr_class
import os
import serasc2bin
import glob

glob_pat = 'km2002_24*'

yearbase = 2002
dir_asc_base = '/home/data/km0202/raw'
dir_bin_base = '/home/data/km0202/rbin'

subdir_messages =  {'adu2': ('gps', 'adu'),  # new version: 'ashtech'
            'gyro': ('hdg',),
            'pcode': ('gps',),               # and 'gpsnav'
            'posmv': ('gps', 'pmv')}


for subdir in subdir_messages.keys():
   A = serasc2bin.asc2bin(yearbase = yearbase, showbad = 0, redo = 1,
                           outfiledir = os.path.join(dir_bin_base, subdir),
                           )
   for msg in subdir_messages[subdir]:
      files = glob.glob(os.path.join(dir_asc_base, subdir, glob_pat))
      files.sort()
      A.translate_files(files[:-1], message = msg)



