#!/usr/bin/python

import string, os, stat, sys, struct, glob, time
from binfile import binfile

vv = 0 ## debug: 0 or 1


def endtime(filelist,index):
   F = binfile(filelist[index])
   reclen = F.read(1)
   allvals = F.read()


## eg: rbingaps.py /mnt/ulili2/uhdas_data/polar/nbp0408_a
   
if __name__ == '__main__':


   if len(sys.argv) == 1:
      print 'usage: rbin_gaps.py uhdas_dir'
      sys.exit()
   
   uhdas_dir = sys.argv[1]
   print 'getting rbin gaps from %s' % (uhdas_dir)
   
   cruiseid = os.path.basename(uhdas_dir)
   rbindirs = glob.glob(os.path.join(uhdas_dir,'rbin','*'))
   for ii in range(0,len(rbindirs)):
      rbindirs[ii] = os.path.basename(rbindirs[ii])
   print 'found rbin dirs: %s' % (' '.join(rbindirs))

   for diri in range(0,len(rbindirs)):
      rbindir = rbindirs[diri]
      filelist = glob.glob(os.path.join(uhdas_dir, 'rbin', rbindir,'*.rbin'))
      filelist.sort()

      suffixes = []
      for fname in filelist:
         rstr= str.split(os.path.basename(fname),'.')
         suffix = rstr[1]
         if suffix not in suffixes:
            suffixes.append(suffix)
            
      print 'found %s suffixes: %s' % (rbindir, ' '.join(suffixes))
      
      for suffix in suffixes:
        
         info = []
         globstr = os.path.join(uhdas_dir, 'rbin', rbindir,'*.%s.rbin' % (suffix))
         if vv: print 'testing globstr %s' % (globstr)
         sfilelist = glob.glob(globstr)
         sfilelist.sort()

         for ifile in range(1,len(sfilelist)):

            if vv: print 'testing file %s' % (sfilelist[ifile-1])

            try:
               F = binfile(sfilelist[ifile-1])
               F.seek(-1,2)
               last_dday =   F.read()[0]               
               F.close()
               
               G = binfile(sfilelist[ifile])
               first_dday = G.read(1)[0]
               G.close()
               
               secs = round(86400*(first_dday - last_dday))
               info.append([sfilelist[ifile-1], last_dday, first_dday, secs])

               outfile = '%s_%s.%s' %(cruiseid, rbindir, suffix)
               if vv: print 'opening outfile %s' % (outfile)
               F = open(outfile,'w')
               F.write(globstr)
               F.write('\n')
               for ii in range(0,len(info)):
                  rec = info[ii]
                  fname = os.path.basename(rec[0])
                  F.write('%40s %10.7f  %10.7f   %d\n' % (fname, rec[1], rec[2], rec[3]))
               F.close()

            except:
               print 'cannot parse file %s' % (sfilelist[ifile-1])
               


