#!/usr/bin/env python

''' Continuous incremental translation of ascii to binary files.

    This is a driver for the serasc2bin routines, providing
    multi-threaded incremental processing of ascii files as
    they are being logged, always working on the most recent
    file.

   Test jig.



'''

import sys, os, glob, threading, time
import test_serasc2bin

sys.path.append('../../py_common')
from threadgroup import *



class Translate(ThreadGroup):

   def __init__(self):
      ThreadGroup.__init__(self)

   def translate(self):
      TT = test_serasc2bin.testclass()
      while self.running:
         TT.runner()
         print "in translate"
         self.timer(0.66)  #  so wait before trying again.

   def stop(self):
      test_serasc2bin.haltflag = 1
      print "set test_serasc2bin.haltflag"
      #time.sleep(2)
      ThreadGroup.stop(self)

   def start(self):
      T = threading.Thread(target = self.translate)
      T.setDaemon(1)
      self.add(T)

      ThreadGroup.start(self)


## Sample use of a Translate object:

if __name__ == '__main__':
   T = Translate()
   T.start()
   time.sleep(4.62)
   T.stop()


