function rrshow = ...
    avg_showverbose(instclass, a, rr)

rr.dday = rr.corr_dday;
rrshow=restruct(instclass, rr);

plot_fig4 = 0;
plot_fig5 = 0;

%% script called by avg.m if showverbose is on -- plots diagnostics


f2;clf   %=================================%

[rrshow, rrconfig] = restruct(instclass,rr);
rrconfig.ord_name='depth';
rrshow.minamp = squeeze(min(rr.amp,[], 2));
if (isfield(rr, 'cor'))
   rrshow.mincor = squeeze(min(rr.cor, [],  2));
end
if (isfield(rr, 'sw'))
   rrshow.maxsw = squeeze(max(rr.sw, [], 2));
end


aplotit(rrshow, rrconfig, 'fn', 'umeas', 'cur_ax', subplot(521));
title('unflagged')
aplotit(rrshow, rrconfig, 'fn', 'umeas', 'flagged', ...
        rr.bmask | rr.instpflag,...
        'cur_ax', subplot(522));
title('flagged')


aplotit(rrshow, rrconfig, 'fn', 'vmeas', 'cur_ax', subplot(523));
title('unflagged')
aplotit(rrshow, rrconfig, 'fn', 'vmeas', 'flagged', ...
                rr.bmask | rr.instpflag,...
        'cur_ax', subplot(524));
title('flagged')


aplotit(rrshow, rrconfig, 'fn', 'minamp', 'comment','MIN AMP', ...
        'cur_ax', subplot(525));
if length(unique(rr.hiamp)) > 1
   aplotit(rr, rrconfig, 'fn', 'hiamp', 'comment','HIAMP', ...
           'cur_ax', subplot(526));
else
   subplot(526);plot(rr.hiamp(:,1),rr.depth); ra(gca); title('hiamp flags')
end

if (isfield(rrshow, 'cor'))
   aplotit(rrshow, rrconfig, 'fn', 'mincor', 'comment','MIN COR', ...
           'cur_ax', subplot(527));
end
if (isfield(rrshow, 'maxsw'))
   if length(unique(rrshow.maxsw)) > 1
      aplotit(rrshow, rrconfig, 'fn', 'maxsw', 'comment','max SW', ...
              'cur_ax', subplot(527));
   end
end
if strcmp(rr.config.pingtype,'son')
   [mm,estd]=mstdgap(rr.emeas');
   subplot(527)
   plot(estd,rr.depth,'b');ra(gca);title('EV std')
end



bad_mask = rr.bmask | rr.bt_bmask | rr.bt_wmask | rr.instpflag | ...
    isnan(squeeze(rr.vel(:,1,:)));

nprofs = length(rr.dday);
subplot(528)
plot(100*sum(rr.hiamp')/nprofs,rr.depth);
title('percent lost HIAMP')
xl(0,100);ra(gca)
subplot(529)
plot(100*sum((rr.bt_bmask|rr.bt_wmask)')/nprofs,rr.depth);
title('percent lost bmask')
xl(0,100);ra(gca)
subplot(5,2,10)
plot(100*sum((rr.instpflag~=0)')/nprofs,rr.depth);
title('percent lost instpflag')
xl(0,100);ra(gca)



f3;clf %=================================%

numreq = 25;
%get rev_avg trefl

cuv = rrshow.umeas + i*rrshow.vmeas;


[mm,ss,nn]=mstdgap(cuv);
[vprofile, trefl] =...
    block_refavg(rrshow.dday, ...
                 dotmmask(bad_mask).*rrshow.umeas + i*rrshow.vmeas, ...
                 [2:20], 10);

% get ship's speed:
% use this to get x and y
[mps, x, y, cog] = ll2mps(rrshow.dday, ...
                          rrshow.nav.txy1(2,:), rrshow.nav.txy1(3,:));
secs = 86400*diff(rrshow.nav.txy1(1,:));

uship = [0 diff(x)./secs];
vship = [0 diff(y)./secs];
mps = abs(uship + i*vship);

trefl_oc = trefl + (uship + i*vship);
trefl_f = real(uv2fp(trefl, rrshow.heading));
trefl_of = real(uv2fp(trefl_oc, rrshow.heading));


jjshort = find(nn < numreq);
jjlong  = find(nn >= numreq);
if (length(jjlong)  == 1),   jjlong  = [jjlong  jjlong];end
if (length(jjshort) == 1),   jjshort = [jjshort jjshort];end


if (~isemptys(jjlong))
   [vplong,trlong]=refavg(cuv(:,jjlong),   [1:20], 3);
   trlong_f = real(uv2fp(trlong, rrshow.heading(jjlong)));
else
   trlong_f = [];
end

if (~isemptys(jjshort))
   [vpshort,trshort]=refavg(cuv(:,jjshort), [1:20], 3);
   trshort_f = real(uv2fp(trshort, rrshow.heading(jjshort)));
   
else
   trshort_f = [];
end

medfilt_mps =   medfilt(mps,15,.5);


set(0,'defaulttextinterpreter','none')
subplot(411)
hh=plot(rrshow.dday, -trefl_f, 'g');
set(hh,'color',.6*[0 1 0],'linewidth',2)
hold on
hh=plot(rrshow.dday, mps,'k');set(hh,'color',.65*[1 1 1])
hh=plot(rrshow.dday, mps,'ko');ms(hh,3);set(hh,'color',.6*[1 1 1])
hh=text(rrshow.dday(1), 4, '   -trefl_f');click_rgbk(hh, 'c',.6*[0 1 0])
hh=text(rrshow.dday(1), 3, ' raw mps ');click_rgbk(hh, 'c', .6*[1 1 1])
hh=text(rrshow.dday(1), 9, '   -trefl_f');click_rgbk(hh, 'c',.6*[0 1 0])
hh=text(rrshow.dday(1), 8, ' raw mps ');click_rgbk(hh, 'c', .6*[1 1 1])
yl([-5 0] + max(1.1*medfilt_mps))
xl(rrshow.dday([1 end]))


subplot(412)
hh=plot(rrshow.dday, -trefl_f, 'g');
set(hh,'color',.6*[0 1 0],'linewidth',2)
hold on
hh=plot(rrshow.dday, mps,'k');set(hh,'color',.65*[1 1 1])
hh=plot(rrshow.dday, mps,'ko');ms(hh,3);set(hh,'color',.6*[1 1 1])
plot(rrshow.dday(jjlong), -trlong_f, 'k.')
plot(rrshow.dday(jjshort), -trshort_f, 'g.');
hh=text(mean(rrshow.dday), 3, ' (short profiles)');
click_rgbk(hh, 'c','g','ha','l')
hh=text(mean(rrshow.dday), 3, '(long profiles)  ');
click_rgbk(hh, 'c','k','ha','r')
hh=text(mean(rrshow.dday), 8, ' (short profiles)');
click_rgbk(hh, 'c','g','ha','l')
hh=text(mean(rrshow.dday), 8, '(long profiles)  ');
click_rgbk(hh, 'c','k','ha','r')
yl([-5 0] + max(1.1*medfilt_mps))
xl(rrshow.dday([1 end]))

subplot(223)
hh=plot(mps, nn, 'r+');ms(hh,4);set(hh,'color',.6*[1 1 1])
hold on;ra(gca)
plot(-trefl_f(jjshort), nn(jjshort),'g.')
plot(-trefl_f(jjlong), nn(jjlong),'k.')
plot([0 max(abs(trefl))+.5]', [numreq numreq]','k')
xlabel('m/s')
ylabel('number of points in profile')
hh=text(.5, 5, '-trefl_f');click_rgbk(hh, 'c','g')



subplot(224)
maxship =max(max(abs(uship)), max(abs(vship)));
uvrange =  [-maxship maxship]*1.1;
plot(uvrange', [0 0], 'color', .8*[1 1 1])
hold on
plot([0 0], uvrange', 'color', .8*[1 1 1])
hh=plot(uship, vship,'r+');set(hh,'color',.6*[1 1 1])
hh=plot(uship(jjlong), vship(jjlong),'k.');
hold on
hh=plot(uship(jjshort), vship(jjshort),'g.');

hh=plot(-uship, -vship,'r+');ms(hh,4);set(hh,'color',.6*[1 1 1])
hh=plot(real(trefl(jjshort)), imag(trefl(jjshort)),'go');ms(hh,4)
hh=plot(real(trefl(jjlong)), imag(trefl(jjlong)),'ko');ms(hh,4)
axis('equal')
xlabel('m/s')
ylabel('m/s')
title('raw ship speed (.), ADCP meas (o)')
xl(uvrange)
yl(uvrange)


%------------------------------------------------------------------
if (plot_fig4)
   f4;clf
   cc = [1 0 0
         0 1 0
         0 0 1
         0 0 0];

   gg = [.5*[1 1 1];
         .5*[1 1 1];
         .5*[1 1 1];
         .5*[1 1 1]];

   lthick = [1 1 1 1];   

   subplot(221)
   plot([0 260], [numreq numreq]','k')
   hold on;ra(gca)
   colored = 'short';
   gray = 'long';

   maxaa = 0;
   for beam = 1:4
      eval(sprintf('aa = rrshow.amp%d;', beam))
                                   % plot gray (background) first
                                   eval(sprintf('index = jj%s;', gray))
                                   mm=mstdgap(aa(:,index)');
                                   maxaa = max(maxaa, max(mm));
                                   plot(mm,rrshow.bins, ...
                                        'color', gg(beam,:),...
                                        'linewidth', lthick(beam));
                                   % plot colored (forground) second
                                   eval(sprintf('index = jj%s;', colored))
                                   mm=mstdgap(aa(:,index)');
                                   maxaa = max(maxaa, max(mm));
                                   plot(mm,rrshow.bins, ...
                                        'color', cc(beam,:),'linewidth',2)
   end
   xl(0,maxaa*1.1)
   title('AGC count, short profiles')


   subplot(222)
   plot([0 260], [numreq numreq]','k')
   hold on;ra(gca)
   colored = 'long';
   gray = 'short';

   maxaa = 0;
   for beam = 1:4
      eval(sprintf('aa = rrshow.amp%d;', beam))
                                   % plot gray (background) first
                                   eval(sprintf('index = jj%s;', gray))
                                   mm=mstdgap(aa(:,index)');
                                   maxaa = max(maxaa, max(mm));
                                   plot(mm,rrshow.bins, ...
                                        'color', gg(beam,:),...
                                        'linewidth', lthick(beam));
                                   % plot colored (forground) second
                                   eval(sprintf('index = jj%s;', colored))
                                   mm=mstdgap(aa(:,index)');
                                   maxaa = max(maxaa, max(mm));
                                   plot(mm,rrshow.bins, ...
                                        'color', cc(beam,:),'linewidth',2)
   end
   xl(0,maxaa*1.1)
   title('AGC count, long profiles')


   % plot means
   subplot(223)
   plot([0 maxaa], [numreq numreq]','k')
   hold on;ra(gca)
   aa=[rrshow.amp1(:,jjshort) ...
       rrshow.amp2(:,jjshort) ...
       rrshow.amp3(:,jjshort) ...
       rrshow.amp4(:,jjshort) ];   
   [mm,ss]=mstdgap(aa');
   if (~isemptys(jjshort))
      fillstd('v',rrshow.bins,'std',ss,'mean',mm);
   end
   hold on;ra(gca)
   hh=plot(mm(1:numreq),rrshow.bins(1:numreq),'c');lw(hh,2)
   hh=plot(mm(numreq:end),rrshow.bins(numreq:end),'c.');
   xl([0 maxaa*1.1])
   mmshort = mm;

   aa=[rrshow.amp1(:,jjlong) ...
       rrshow.amp2(:,jjlong) ...
       rrshow.amp3(:,jjlong) ...
       rrshow.amp4(:,jjlong) ];   
   [mm,ss]=mstdgap(aa');
   mmlong = mm;
   hh=plot(mm,rrshow.bins,'m');lw(hh,2)
   plot([mm'-ss' mm'+ss']',[rrshow.bins rrshow.bins]','m-')
   hh=text(50,35,'short profiles');click_rgbk( hh, 'c', 'c','s',12)
   hh=text(50,40,'long profiles');click_rgbk( hh, 'c', 'm','s',12)


   subplot(224)
   plot([-20 20], [numreq numreq]','k')
   hold on;ra(gca)
   plot([0 0]',[0 rrshow.bins(end)]','m');
   plot(mmshort - mmlong, rrshow.bins,'c')
   ra(gca)
   hh=text(rrshow.bins(end)-3,40,'AGC: long - short profiles');
   click_rgbk( hh, 'c', 'k','s',12,'ha','c')
   xl([-10,10])

end

%-------------------------------------------------------

if (plot_fig5)
   f5;clf
   nr = 1:5:length(rrshow.bins);
   nri = [nr;[nr(2:end)-1 length(rrshow.bins)]];
   if (nri(2,end-1) == nri(2,end))
      nri(:,end)=[];
   end
   NR = length(nr(1,:));

   % AGC for varying profile depths
   amean = NaN*zeros(length(rrshow.bins), NR);  % numbins x numreqbins
   profcount = zeros(1,NR);  % number of profiles like this
   ocf = NaN*zeros(1,NR);  % forward direction ocean velocity

   for nrcount = 1:NR
      ii=find( (nn >= nri(1,nrcount)) & (nn <= nri(2,nrcount)));
      profcount(nrcount) = length(ii);
      if (length(ii) > 1)
         aa=[rrshow.amp1(:,ii) ...
             rrshow.amp2(:,ii) ...
             rrshow.amp3(:,ii) ...
             rrshow.amp4(:,ii) ];   
         amean(:,nrcount) = mstdgap(aa')';
         [vp, tr] = refavg(rrshow.umeas(:,ii) + i*rrshow.vmeas(:,ii), [2:20], 3);
         ocf(nrcount) = ...
             mstdgap(real(uv2fp(tr + (uship(ii) + i*vship(ii)), rrshow.heading(ii))));
      end
   end


   subplot(141)
   plot([0 0],[0 rrshow.bins(end)]','k');hold on
   if (~isemptys(jjshort))
      hh=plot(mstdgap(trefl_of(jjshort))*[1 1]', [1 numreq]','g-');lw(hh,2)
   end
   if (~isemptys(jjlong))
      hh=plot(mstdgap(trefl_of(jjlong))*[1 1]', [numreq length(rrshow.bins)]','k-');
   end
   set(hh,'linewidth',2,'color',.5*[1 1 1])
   hh=plot([ocf' ocf']',[nri(1,:)' nri(2,:)']', 'k.-');lw(hh,2)
   ra(gca)
   title('mean fwd oc vel')
   ylabel('# bins in profile')
   xlabel('m/s')
   xl(-1,2)

   subplot(142)
   hh=plot([profcount' profcount']',[nri(1,:)' nri(2,:)']', 'r.-');lw(hh,2)
   ra(gca)
   title('# profiles')
   xlabel('m/s')


   %amean  is nbins x (vector of number of bins required)
   ii=find( nn>25);
   if (length(ii) > 1)
      aa=[rrshow.amp1(:,ii) ...
          rrshow.amp2(:,ii) ...
          rrshow.amp3(:,ii) ...
          rrshow.amp4(:,ii) ];   
      abase =  mstdgap(aa')';
      amean_detrended = amean - repmat(abase, 1, NR);
   else
      aa=[rrshow.amp1 ...
          rrshow.amp2 ...
          rrshow.amp3 ...
          rrshow.amp4 ];   
      abase =  mstdgap(aa')';
      amean_detrended = amean - repmat(abase, 1, NR);
   end

   subplot(122)
   cmap = flipud(jet(NR));
   for ii=1:NR
      plot(amean_detrended(:,ii),rrshow.bins,'color',cmap(ii,:))
      hold on
   end
   ra(gca)
   xlabel('amplitude - longprofile AGC')


end


f6
aplotit(rrshow, rrconfig, 'fn', 'cleaned_amp1', 'comment','clean amp1', 'cur_ax', subplot(221));
aplotit(rrshow, rrconfig, 'fn', 'cleaned_amp2', 'comment','clean amp2', 'cur_ax', subplot(222));
aplotit(rrshow, rrconfig, 'fn', 'cleaned_amp3', 'comment','clean amp3', 'cur_ax', subplot(223));
aplotit(rrshow, rrconfig, 'fn', 'cleaned_amp4', 'comment','clean amp4', 'cur_ax', subplot(224));




keyboard