function [allvp, trefl] = block_refavg(dday, vel, binindex, blsize)
% [trefl, blockvp] = block_refavg(dday, vel, binindex, blocksize)
% dday is 1xn
% vel is nbinsxnprofs (can be complex)
% binindex is reference layer bins
% blocksize is number of profiles to use in refavg
% blockvp and trefl are vertical profile (from blocks of vel) and trefl

trefl = NaN*ones(size(dday));

ranges = [         [1:blsize:length(dday)] ; 
          blsize-1 + [1:blsize:length(dday)]];
ranges(2,end)=length(dday);
if (ranges(2,end) - ranges(1,end) < 3)
   ranges(2,end-1) = ranges(2,end);
   ranges(:,end) = [];
end


allvp = NaN*ones(length(vel(:,1)), length(ranges(1,:)));

for rangei=1:length(ranges(1,:))
   ii = ranges(1,rangei):ranges(2,rangei);
   [allvp(:,rangei), trefl(ii)] = refavg(vel(:,ii), binindex, 3);
end

   