function nani = find_gaps(logger_dday, serdata_dday, gap_seconds)
%find time ranges from logged serial data (serdata_dday) greater than gap_sec 
%return indices into logger_dday where NaNs should be placed due to gaps

serdata_dday = serdata_dday(:);  %need a column vector

gapi = find(diff(serdata_dday)*86400 >= gap_seconds);
nani = [];
if (~isemptys(gapi))
   gaptimes =  [serdata_dday(gapi) serdata_dday(gapi + 1)]; %serial data times
   for gapnum = 1:length(gapi) %find indices in logger_ddday
      newnani = find( (logger_dday >= gaptimes(gapnum(1),1) ) &...
                 (logger_dday <= gaptimes(gapnum(end),2)));
      nani = [nani; newnani];
   end
end

