function ens_mean = get_ensmean(r, enu, bad_mask)
% ens_mean = get_ensmean(r, enu, bad_mask)
%% output average lon, lat; average shipu, shipv; 
% called by avg.m



[junk, x, y] = ll2mps(r.nav.txy2(1,:), r.nav.txy2(2,:), r.nav.txy2(3,:));
secs = 86400*diff(r.nav.txy2(1,:));

if (isemptys(x))
   uship = NaN*secs;
   vship = NaN*secs;
else
   uship = [diff(x)./secs]; uship = [uship uship(end)];
   vship = [diff(y)./secs]; vship = [vship vship(end)];
end
   
   
ens_mean.lon = mstdgap(r.nav.txy2(2,:));
ens_mean.lat = mstdgap(r.nav.txy2(3,:));
ens_mean.uship = mstdgap(uship);
ens_mean.vship = mstdgap(vship);



