function a2 = mk_ancil2(a, avg_flag)

%% a2 is a shipboard ADCP ancil_2 structure represented
%% as a double array.
%% a is a structure from read(instclass, ...

if nargin == 1, avg_flag = 0; end

NP = length(a.heading);

aa2 = NaN * ones(23, NP);
ii = ancil2_ind;


aa2(ii.mn_pitch,:)       = a.pitch.';
aa2(ii.mn_roll,:)        = a.roll.';

%this may be stupid, but they need to be initialized
aa2(ii.last_temp,:)      = a.temperature';
aa2(ii.last_heading,:)   = a.heading';
aa2(ii.last_pitch,:)     = a.pitch.';
aa2(ii.last_roll,:)      = a.roll.';

aa2(ii.std_temp,:)       = a.temperature.';
aa2(ii.std_heading,:)    = a.heading.';
aa2(ii.std_pitch,:)      = a.pitch.';
aa2(ii.std_roll,:)       = a.roll.';

aa2(ii.last_good_bin,:) = a.config.ncells;
aa2(ii.watrk_hd_misalign,:) = 0;
aa2(ii.botrk_hd_misalign,:) = 0;
if isfield(a, 'velscale')
   aa2(ii.watrk_scale_factor,:) = a.velscale;
   aa2(ii.botrk_scale_factor,:) = a.velscale;
else
aa2(ii.watrk_scale_factor,:) = 1;
aa2(ii.botrk_scale_factor,:) = 1;
end
aa2(ii.pit_misalign,:) = 0;
aa2(ii.rol_misalign,:) = 0;

if avg_flag,
   a2 = aa2(:,1);                %return aa2 but overwrite these next fields


   % temperature
   [mm,ss] = mstdgap(a.temperature);
   a2(ii.std_temp)            = ss;
   ilast                 = max(find(~isnan(a.temperature)));
   if (~isemptys(ilast))
      a2(ii.last_temp)        = a.temperature(ilast);
   else
      a2(ii.last_temp)        = NaN;
   end
   
   % pitch
   [mm,ss] = mstdgap(a.pitch);
   a2(ii.std_pitch)           = ss;
   ilast                 = max(find(~isnan(a.pitch)));
   if (~isemptys(ilast))
      a2(ii.last_pitch)       = a.pitch(ilast);
   else
      a2(ii.last_pitch)       = NaN;
   end
   % roll
   [mm,ss] = mstdgap(a.roll);
   a2(ii.std_roll)            = ss;
   ilast                 = max(find(~isnan(a.roll)));
   if (~isemptys(ilast))
      a2(ii.last_roll)        = a.roll(ilast);
   else
      a2(ii.last_roll)       = NaN;
   end
   % heading
   unwrapped_head = 180*(unwrap(a.heading*pi/180))/pi;
   [mm,ss] = mstdgap(unwrapped_head);
   a2(ii.std_heading)         = ss;
   ilast                 = max(find(~isnan(a.heading)));
   if (~isemptys(ilast))
      a2(ii.last_heading)     = a.heading(ilast);
   else
      a2(ii.last_heading)     = NaN;
   end
   
   a2(ii.last_good_bin) = a.config.ncells;
else
   a2 = aa2;
end

a2(isnan(a2)) = 1e38;


