function b = mk_bt(a, avg_flag)

%% b is a shipboard ADCP BOTTOM_TRACK structure represented
%% as a double array.
%% a is a structure from read(instclass, ...
%%%% expect first two variables are umeas and vmeas
if nargin == 1, avg_flag = 0; end

%enu and vel synonymous here

if isfield(a.bt,'enu')
   bb = [a.bt.enu(1:2, :); mean(a.bt.range)];
else
   bb = [a.bt.vel(1:2, :); mean(a.bt.range)];
end   


%% b is 3xN
if avg_flag,
   b = mstdgap(bb, 2)';
else
   b = bb;
end

%  if there are NaNs in velocity:
badi = find(isnan(sum(b([1 2],:))));
if ~isemptys(badi)
   b(:,badi) = 1e38;
end

%  if everything is zero
badi = find(...
   (b(1,:) == 0) & ...
   (b(2,:) == 0) & ...
   (b(3,:) == 0));
if ~isemptys(badi)
   b(:,badi) = 1e38;
end



