function c1 = mk_config1(a)

%% c1 is a shipboard ADCP configuration_1 structure represented
%% as a double array.
%% a is a structure from read(instclas,...)

ii = config1_ind;
c1 = 1e38 * ones(length(ii), 1);



c1(ii.num_bins)             = a.config.ncells;
c1(ii.bin_length)           = a.config.cell;
c1(ii.pls_length)           = a.config.pulse;
c1(ii.blank_length)         = a.config.blank;
c1(ii.tr_pressure)          = a.config.tr_pressure;
c1(ii.freq_transmit)        = a.config.frequency * 1000;


c1(ii.hd_offset)            = a.config.head_align;
c1(ii.heading_bias)         = a.config.head_bias;

c1(ii.bot_track)            = 255*a.config.bt_was_on;


if (length(a.dday)) == 1;
   c1(ii.avg_interval)        = NaN;
else
   c1(ii.avg_interval)        = round(86400*median(diff(a.dday)));
end

%NOTE: probably need to decode this from config
c1(ii.compensation)         = 1;   
%NOTE: number of pings pre-averaged before DAS
c1(ii.pgs_ensemble)         = 1;   
c1(ii.top_ref_bin)          = a.top_ref_bin;
c1(ii.bot_ref_bin)          = a.bot_ref_bin;
c1(ii.ev_threshold)         = a.ev_threshold;

