% Directory tree for raw logging and processing
% (example for km0401), 
% root directory is km0401, all others below that:
%
%   
%   km0401/
%        raw/
%             os38/
%             son125/
%             pcode/
%             gyro/
%             posmv/
%             adu2/
%   
%        rbin/
%             pcode/
%             gyro/
%             posmv/
%             adu2/
%             
%        gbin/
%             os38/
%                  time/
%                  pcode/
%                  gyro/
%                  posmv/
%                  adu2/
%             son125/
%                  time/
%                  pcode/
%                  gyro/
%                  posmv/
%                  adu2/
%              
%       proc/
%           config/            (contains km0401_cfg.m, km0401_proc.m )
%           log/               (contains record of serial data dialogs)
%           os38b/             (os38 bb processing; created by adcptree.py)
%           os38n/             (os38 bb processing; created by adcptree.py)
%           son125/            (sontek processing; created by adcptree.py)
%   
%   
%   ... where:
%   os38 and son125 are instrument names
%   os, son are instrument classes (respectively)
%   
%   os38b is for os38 'bb' pings
%   os38n is for os38 'nb' pings
%   son125 is for the sontek data
%
%--------------------
% 
%  in the 'load' subdirectory of the processing directory, "load_uh.m"
%  runs through the raw files, calling "load_raw" which 
%  takes 5-minute chunks of adcp data, adds navigation and attitude
%  from gbin files, edits it, averages it, and writes it to disk.
%
%  "ldcodas" loads these data into a codas database.
%
%  see (system command line) quick_adcp.py for other processing steps
%  do "help rawadcp" for an overview of the suite of matlab programs
%  do "help uhdas_plots" for an overview of making gbin files and 
%          accessing data after gbin files are available
