function data = rawfp(data, os_cutoff);
%data = rawfp(data, mps_cutoff);
% add fields for fore and port (data.fmeas data.pmeas) for measured
%  speeds over mps_cutoff (NaNs otherwise)
% 

if (nargin == 1)
   os_cutoff = 2;
end
dummy1 = ones(size(data.bins(:,1)));   %Nx1

refl = [6:12];
rads = (90-data.heading(:)')*pi/180;   %1XN

osmask = ones(size(data.dday(:)'));    %go sideways

mps = mstdgap(abs(data.umeas(refl,:) + i*data.vmeas(refl,:)));
osmask(find(mps) <= os_cutoff) = NaN;

%foreport of measured vel
fp = (data.umeas + i*data.vmeas).*exp(-i*dummy1*rads);
data.fmeas = (dummy1*osmask).*real(fp);
data.pmeas = (dummy1*osmask).*imag(fp);
