function logdata = read_logfile(logfile)
% logdata = read_logfile(logfile)
% raw adcp data uhdas logfiles may have the first 3, 4, or 5 fields:
%      pcdday, startbyte,  numbytes, ensnum, instdday,
% and there is a small set where there are 4 columns but the last column is "(null)"

%this program is called by mk_gbin and is separated for easier testing
% and better documetation


if ~exist(logfile)
   logdata = [];
   fprintf('BIG ERROR-- missing log file')
   return
end


      try %all logfiles are the first 2, 3, 4, or 5 of these
         logdata = load(logfile);
      catch %error: should be 5 fields; is 4 with last ascii
         [log_pcdday,log_startbyte,log_numbytes, log_ensnum] = ...
             textread(logfile,'%f%d%d%s');
         logdata =   [log_pcdday,log_startbyte,log_numbytes];
      end
