gbinfiles = dirs('gbinfiles/*adu.gbin');

g_dday = 1;
g_head = 2;
g_pitch = 3;
g_roll = 4;

starti = 1;
allgbin = NaN*ones(2, 6600*length(gbinfiles));
for filei = 1:length(gbinfiles)
   gbinfile = gbinfiles(filei).name;
   gbindata = read_bin(['gbinfiles/',gbinfile]);
   N = length(gbindata(1,:));
   allgbin(:,[starti : starti + N - 1])  = gbindata([g_dday g_pitch],:);
   starti = starti + N;
end

badi = find(isnan(allgbin(1,:)));
allgbin(:,badi) = [];


fprintf('getting a running stddev of pitch')
%get a 5 minute running std dev of pitch
dt = 5*60/86400;
gbin_t = [allgbin(g_dday,1) : dt : max(allgbin(g_dday,:)) + dt];
gbin_std = NaN*gbin_t(1:end-1);
for starti = 1:length(gbin_std)-1
   ii = find( (allgbin(g_dday,:) >= gbin_t(starti)) & ...
              (allgbin(g_dday,:) <= gbin_t(starti+1)));
   [mm ss] = mstdgap(allgbin(2, ii));
   if (~isemptys(ss))
      gbin_std(starti) = ss;
   end
end


plot(gbin_t(1:end-1), gbin_std,'r')

   
