function nrows = bin_nrows(binext)
% nrows = bin_nrows(binext)
%
% fext is one of:          with nrows:
%
%    'adu.bin'                  8
%    'adu.gbin'                 7
%    'hdg.bin'                  2
%    'hdg.gbin'                 1
%    'gps.bin'                  4
%    'gps.gbin'                 5
%    'spd.gbin'                 2
%    'spd.bin'                  1



if (binext(1) == '.')
   binext(1) = [];
end


if (strmatch(binext, 'adu.bin')),    
   nrows =  8  ;
elseif (strmatch(binext, 'adu.gbin')),   
   nrows =  6  ;
elseif (strmatch(binext, 'hdg.bin')),    
   nrows =  2  ;
elseif (strmatch(binext, 'hdg.gbin')),  
   nrows =  1  ;
elseif (strmatch(binext, 'gps.bin')),
   nrows =  4  ;
elseif (strmatch(binext, 'gps.gbin')),   
   nrows =  5  ;
elseif (strmatch(binext, 'spd.bin')),    
   nrows =  2  ;
elseif (strmatch(binext, 'spd.gbin')),   
   nrows =  1  ;
else
   help bin_nrows
   error('no bin extension found')
end










