function errstd_binmask = errstd_binedit(emeas, errstd_cutoff, errstd_binval)
% errstd_binmask = errstd_binedit(emeas, errstd_cutoff, errstd_binval)
% called by pingedit
% returns a pflag mask with errstd_binval where err velocity stddev
%    excedes errstd_cutoff


errstd_binmask = zeros(size(emeas));   

[mm,ss]= mstdgap(emeas');
ssM = repmat(ss', 1, length(emeas(1,:)));  %matrix of std profiles
errstd_binmask(ssM > errstd_cutoff) = errstd_binval;


