function [val_binmask, std_binmask, vprofile, trefl, resid] = ...
    refavg_binedit(vel, rl_range, valcutoff, stdcutoff, val_binval, std_binval)
%  [val_binmask, std_binmask, vprofile, trefl, resid] = ...
%    refavg_binedit(vel, rl_range, valcutoff, stdcutoff, val_binval,std_binval);
%  find vertical profile and timeseries  from refavg; find residual
%  return pflag for residual outliers baded on value or stddev, 
%          vertical profile and reflayer timeseries for velocity, and residual
%
%


% most of the outlier removal in this routine has been replaced by outlier_binedit

%% first get rid of outliers

val_binmask = zeros(size(vel));
std_binmask = zeros(size(vel));


if ~isemptys(rl_range)
   rlbins = rl_range(1):rl_range(2);
else
   rlbins = 1:length(vel(:,1));
end

vprofile = [];
trefl = [];
%run refavg
[vprofile, trefl]   =  refavg(vel,  rlbins, 3);


vprofileM = repmat(vprofile, 1, length(vel(1,:)));
treflM = repmat(trefl, length(vel(:,1)), 1);
resid = vel - (vprofileM + treflM);
   
%throw out resid outliers based on velocity 
if ~isemptys(valcutoff)
   val_binmask(abs(resid) > valcutoff)  = val_binval;
end
resid(val_binmask~= 0) = NaN;
vel(val_binmask~= 0) = NaN;
   
%throw out resid outliers based on std
if ~isemptys(stdcutoff)
   [junk, stddev] = mstdgap(resid(:));
   std_binmask(abs(resid) > abs(stddev)*stdcutoff) = std_binval;
end
resid(std_binmask~= 0) = NaN;
vel(std_binmask~= 0) = NaN;

%now apply it and get vprofile and trefl
[vprofile, trefl]   =  refavg(vel,  rlbins, 3);



