function sw_binmask = sw_binedit(sw, sw_cutoff, sw_binval)
%sw_binmask = sw_binedit(sw, sw_cutoff, sw_binval)
% called by pingedit
% returns a pflag mask with sw_binval where sw excedes sw_cutoff

if length(size(sw)) == 3
   sw_binmask = zeros(size(squeeze(sw(:,1,:))));
   for beam = 1:4
      sw_binmask(squeeze(sw(:,beam,:)) > sw_cutoff) = sw_binval;
   end
else
   sw_binmask = zeros(size(sw));
   sw_binmask(sw > sw_cutoff) = sw_binval;
end

