function  weakprof_mask = weakprof_edit(pflag, bmask, weakprof_binsreq, ...
                                        weakprof_testrange, weak_binval);
%  weakprof_mask = weakprof_edit((pflag, bmask, weakprof_binsreq, ...
%                                        weakprof_testrange, weak_binval);
% remove profiles with too few bins in specified range



weakprof_mask = zeros(size(pflag));
[NR, NC] = size(pflag);

maxamp = max(sum(~bmask), 1);


% make test range stop above the bottom
testrange_startbin = repmat(weakprof_testrange(1),1,length(pflag(1,:)));
testrange_startbin = min(maxamp, testrange_startbin);

testrange_endbin = repmat(weakprof_testrange(2),1,length(pflag(1,:)));
testrange_endbin = min(maxamp, testrange_endbin);

% make a mask that is zeros for data to be tested
profbins = zeros(size(pflag));
profbins(testrange_startbin + [0:(NC-1)]*NR)=1;
profbins(testrange_endbin + [0:(NC-1)]*NR)=1;
profbins = rem(cumsum(profbins),2);

% number of bins required should not excede number of bins available
bins_available = testrange_endbin - testrange_startbin + 1;
% might want to make this greater than 50percent
weakprof_binsreq = min(weakprof_binsreq, floor(.5*bins_available));

%                  (  1 if good) & (1 if testit)
weakprofs = sum((pflag == 0) & profbins) < weakprof_binsreq;
weakprofsM = repmat(weakprofs, NR, 1);
weakprof_mask = weak_binval * weakprofsM;

%%   weakprof_mask1 = weakprof_edit(pflag, data.bmask, cfg.weakprof_binsreq, ...
%%                                  cfg.weakprof_testrange, weak_binval);

