function mask =  refavg_outlier_edit(vel, editcfg)
% mask =  refavg_outlier_edit(vel, editcfg)
% who: called by pingedit
% output: returns a mask with 1 where residual excedes value or stddev threshold
% input:  (1) velocity, profile flags applied (as NaNs)
%         (2) editcfg:  structure from get_pedefaults, containing 
%                fields "refavg_valcutoff", "refavg_stdcutoff", and "rl_bins"
 

if ~isfield(editcfg, 'refavg_valcutoff')
   fprintf('editcfg does not contain required field refavg_valcutoff\n')
   mask = [];
   return
end

if ~isfield(editcfg, 'refavg_stdcutoff')
   fprintf('editcfg does not contain required field refavg_stdcutoff\n')
   mask = [];
   return
end


if ~isfield(editcfg, 'rl_bins')
   fprintf('editcfg does not contain required field rl_bins\n')
   mask = [];
   return
end


[vprofile, trefl, resid]   =  refavg(vel,  editcfg.rl_bins, 3);
   
%throw out resid outliers based on velocity 
mask = zeros(size(vel));
mask(abs(resid) > editcfg.refavg_valcutoff) = 1;


[junk, stddev] = mstdgap(resid(:));
mask( abs(resid) > abs(stddev)*editcfg.refavg_stdcutoff) = 1;


