function  mask = weak_profile_edit(vel, editcfg)
% mask = weak_profile_edit(vel, editcfg)
% who: called by pingedit
% output: returns a mask with 1 if too few good bins
% input: (1) velocity, with NaN where data are bad (from pflag)
%        (2) editcfg: structure from get_pedefaults, containing 
%              fields "weakprof_testrange", 
%          

% JH. revamped 2004/09/18

[NR, NC] = size(vel);

if ~isfield(editcfg, 'weakprof_testbins') 
   fprintf('no weakprof_testbins field in editcfg structure\n') 
   mask=[];
   return
end
if ~isfield(editcfg, 'weakprof_numbins') 
   fprintf('no weakprof_numbins field in editcfg structure\n') 
   mask=[];
   return
end

numbins_required = editcfg.weakprof_numbins;
testbins = editcfg.weakprof_testbins;

[NC, NR] = size(vel);
testbins(testbins>NC) = [];

goodvels = ~isnan(vel(testbins,:));
numgood = sum(goodvels);


profmask = zeros(size(vel(1,:)));
profmask( numgood <= numbins_required) = 1;  %(1 X NC) is 1 if weak 
mask = repmat(profmask, NC, 1);

