% get tr2ilist from gbin/time
% choose a time range, step
% get data from time range
% look at overview
set(0,'defaulttextinterpreter','none')

%%%%%%%%%%%    edit this section %%%%%%%%%%%

cfg =get_uhdascfg(...
   'instname',    instname, ...
   'instclass',   instclass, ...
   'cfgpath',     cfgpath, ...
   'cfgbase',     cfgbase, ...
   'pingtype',    pingtype);


%%%%%% make some guesses: write, then edit %%%%%%%%%%%
defaults    = 'default_editcfg';
cleanbottom = 'cleanbottom_editcfg'; 
icybottom   = 'icybottom_editcfg';   
deepocean   = 'deepocean_editcfg';   
experimental = 'experimental_editcfg';
write_editcfg(cfg.instclass, cfg.pingtype, defaults, 'verbose', 0);
write_editcfg(cfg.instclass, cfg.pingtype, experimental);
%write_editcfg(cfg.instclass, cfg.pingtype, cleanbottom);
%write_editcfg(cfg.instclass, cfg.pingtype, icybottom);
%write_editcfg(cfg.instclass, cfg.pingtype, deepocean);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
snum = menu('secinfo start:',...
            'from previously saved info',...
            'start over')
secinfo = struct;
secnum = 1;
if snum == 1  % override
   load secinfo
else
   txyz = get_txyz(cfg, 'savename', 'topo.mat');
end
dday = txyz(:,1);
lon =  txyz(:,2);
lat =  txyz(:,3);
zz  =  txyz(:,4);

ddrange = [txyz(1,1) txyz(end,1)];
txyz_ii=1:length(txyz(:,1));


filelist = dirs(fullfile(cfg.gbindir, 'time', '*.tim.gbin'), 'fullfile', 1)
trinfo = gtr2ilist(filelist);

           

%%%%%%%% get a ddrange to investigate %%%%%%%%%%

while(1)
   secnum = secnum + 1;
   moresecnum = menu('get another section?',...
                     'yes','quit')
   if moresecnum == 1

      ddrange = sel_dday('topo.mat', txyz, 2);
         
      %%  menunum = menu('get dday range (choose method):',...
      %%                'crude topo map',...
      %%                'gxytzoom (with map)',...
      %%                'gxytzoom (lon, lat, dday)',...
      %%                'gxytzoom: lon, depth, dday',...
      %%                'gxytzoom: depth, lat, dday');
      %% 
      %% if menunum == 1
      %%    ddrange = sel_dday('topo.mat', txyz, 2);
      %% elseif menunum == 2
      %%    ii=gxytzoom_map(txyz(:,2), txyz(:,3), txyz(:,1), ...
      %%                    'bathymetry', 'topo.mat');
      %%    ddrange = txyz(ii([1 end]),1);
      %% elseif menunum == 3
      %%    ii=gxytzoom(lon, lat, dday);
      %%    ddrange = txyz(ii([1 end]),1);
      %% elseif menunum == 4
      %%    ii=gxytzoom(lon, zz, dday);
      %%    ddrange = txyz(ii([1 end]),1);
      %% else
      %%    ii=gxytzoom(zz, lat, dday);
      %%    ddrange = txyz(ii([1 end]),1);
      %% end
      
      %% get coarse data to explore
      [cdata, cconfig] = get_cdata(cfg, 'step', 30, 'ddrange', ddrange);
      cdata.lon = cdata.lon -360;
      plot(cdata.lon, cdata.lat, 'r.')
      
      
      %% look at effects of editing:
      while (1)
         testnum = menu('test editing:',...
                        'on a new segment',...
                        'done testing; choose editcfg file', 'quit');
         if testnum == 1
            [rr, rconfig] = test_qe(cfg, cdata, cconfig, defaults);
            rr.lon = unwrap(rr.lon-360);
            
            while (1)
               editnum = menu('test editing with:',...
                              'defaults',...
                              'deep ocean',...
                              'shallow and icy',...
                              'shallow, no ice',...
                              'experimental',...
                              'done testing on this ensemble'); 
               if editnum == 1
                  rr = test_qe(cfg, cdata, cconfig, defaults, rr, rconfig );
               elseif editnum == 2
                  rr = test_qe(cfg, cdata, cconfig, deepocean , rr, rconfig);
               elseif editnum == 3
                  rr = test_qe(cfg, cdata, cconfig, icybottom, rr, rconfig);
               elseif editnum == 4
                  rr = test_qe(cfg, cdata, cconfig, cleanbottom, rr, rconfig);
               elseif editnum == 5
                  rr = test_qe(cfg, cdata, cconfig, experimental, rr, rconfig);
               else
                  break
               end
            end
         elseif testnum == 2
            break
         else
            return
         end
      end

      %select bailout date, write list of raw files to filelist
      mapmenu = menu('choose segment end dday:',...
                     'with a topo map',...
                     'using amplitude pcolor plot', 'quit');
      fprintf('click ones for dday at end of segment\n')
      if mapmenu == 1
         enddday = sel_dday('topo.mat', ...
               [cdata.corr_dday(:), cdata.lon(:), cdata.lat(:)], 1);
      elseif mapmenu == 2
         hh=aplotit(cdata, cconfig, 'fn','amp1', ...
                 'var_range', [ 20 240]);
         axes(hh.cur_ax);
         [enddday,junk]=ginput(1);
      else
         return
      end
      dday_bailout  = min(enddday, cdata.corr_dday(end));

      %% trim original times for reuse...
      txyz_ii = find(txyz(:,1) > dday_bailout);
      txyz = txyz(txyz_ii,:);
      dday = txyz(:, 1);
      lon  = txyz(:, 2);
      lat  = txyz(:, 3);
      zz   = txyz(:, 4);
      
      % choose editing file
      efilenum = menu('choose final editing file:',...
                      'defaults',...
                      'deep ocean',...
                      'shallow and icy',...
                      'shallow, no ice');
      if efilenum == 1; 
         efilename = defaults; 
      elseif efilenum == 2
         efilename = deepocean;
      elseif efilenum == 3
         efilename == icybottom;
      else
         efilename = cleanbottom;
      end

      secinfo(secnum).efile = efilename;
      secinfo(secnum).ddayrange = [ddrange(1) dday_bailout];
      secinfo(secnum).trinfo = gtr2ilist(filelist, ...
                                       'timerange', ...
                                       [ddrange(1) dday_bailout]);

      
      save secinfo secinfo secnum txyz
   else
      break
   end
end
   


%% not finished:
%         write_secfilelist(trinfo, startdd, enddd, filename)
% write filelist to seci.filelist
