function [ddays] = sel_dday(toponame, txy, numclicks)
% [ddays] = sel_dday(toponame, txy)
% toponame is matlab file with longrid, latgrid, topog (from get_xyzt)
% txy are [lon lat dday]
% 
% instructions: zoom in as desired, turn off zoom,
%       click on as many points as desired to get dday
%
% name                default                      what
% ----------

%% should redo with a decent projection !!

dday = txy(:,1);
lon = txy(:,2);
lat = txy(:,3);

load(toponame)
figure(333)
clev = [ -3000 -2000 -1000 -500 0];  % topo contour levels
clf
contour(longrid, latgrid, topog, clev)
hold on
colormap(mk_cmap(length(clev), 'topo'));
axis('equal')
contourf(longrid, latgrid, topog, [0 0])

%%%
hold on
plot(lon, lat,'g.')

if nargin == 3
   if numclicks == 1
      str = sprintf('ready to click once on map\n');
   else
      str = sprintf('ready click %d times on map\n', numclicks);
   end
   
   menunum = menu('zoom in on map, then choose below',...
          str);
   [xstart, ystart] = ginput(numclicks);
else
   
   menunum = menu('zoom in on map, then choose below',...
              'ready to  click on map once',...
              'ready to  click on map twice',...
              'ready to  click on map many times');
   if menunum == 1
      [xstart, ystart] = ginput(1);
   elseif menunum == 2
      [xstart, ystart] = ginput(2);
   else
      [xstart, ystart] = ginput;
   end
end


ddays = NaN*ones(1,length(xstart));
ddindex = NaN*ones(1,length(xstart));
%
for ddi = 1:length(ddays)
   [junk, ii]=min( (xstart(ddi) - lon).^2 + (ystart(ddi) - lat).^2);
   ddays(ddi) = dday(ii(1));
   ddindex(ddi) = ii(1);
end
hold on

