function [rr, config] = test_qe(cfg, cdata, cconfig, filename, rr, rconfig);
% [rr, rconfig] = test_qe(cfg, cdata, cconfig, filename, rr, rconfig);
% cfg is from get_uhdascfg
% [cdata, cconfig] are from getsome_adcp
% cfig = figure to click on (from get_cdata)
% filename is editcfg filenaem to use for testing
% [rr, rconfig] are raw data (recycled from 

if strcmp(filename(end-1:end), '.m')
   filename = filename(1 :end-1);
end

if nargin == 6
   dd = rr;
   config = rconfig;
elseif  nargin == 5
   fprintf('error: test_requires 4 or 6 arguments\n')
   help mfilename
   return
else
   f1
   pcfg = aplotit(cdata, cconfig, 'fn','amp1');
   axes(pcfg.cur_ax);
   [startdd,junk] = ginput(1);
   ddrange = [startdd startdd+300/86400];
   
   [dd, config]=getsome_adcp(cfg,'instclass', cfg.instclass,...
                                 'instname', cfg.instname,...
                                 'ddrange', ddrange,...
                                 'pingtype', cfg.pingtype);
end

 
% reset editing parameters 
params = cfg.params;
params.pingedit = 'all';
params.showverbose = 0;
eval(filename);


% average it
[a,rr] =avg(cfg.instclass, dd,  cutadcp(dd,1), params);

dd.mins = 24*60*(dd.dday - dd.dday(1));
rr.mins = 24*60*(rr.dday - rr.dday(1));

   
  
config.abc_name = 'mins';
config.ord_name = 'depth';
config.as_title = 1;

%%%%%%%%%%%%%%% plot velocities %%%%%%%%%%%%%%%

f2;clf
aplotit(dd, config, 'fn','amp1', ...
        'var_range', [ 20 240],...
        'cur_ax', subplot(411));

cc=aplotit(dd, config, 'fn','fabs', ...
           'var_range', [ -1 1],...
           'comment', 'fabs, unedited',...
           'cur_ax', subplot(412));

cc=aplotit(dd, config, 'fn','fabs', ...
           'var_range', [ -1 1],...
           'flagged', rr.instpflag,...
           'comment', 'fabs, EDITED',...
           'cur_ax', subplot(413));


subplot(427)
hh=plot(refavg(rr.fabs , [2:30], 3), dd.depth,'r');lw(hh,2)
hold on
ra(gca)
hh=plot(refavg(dotmmask(rr.instpflag).*rr.fabs , [2:30], 3), dd.depth,'ko-');
ms(hh,4)
xlims = get(gca,'xlim')
hh=text(xlims(2) - .1, 100, 'fabs, orig');
click_rgbk(hh,'c','r','s',12, 'ha','r')
hh=text(xlims(2) - .1, 200, 'fabs, edited');
click_rgbk(hh,'c','k','s',12, 'ha','r')


subplot(428)
hh=plot(100*sum(~isnan(rr.vel1'))/length(rr.dday), rr.depth,'r');lw(hh,2)
hold on
ra(gca)
hh=plot(100*(sum((rr.instpflag == 0)'))/length(rr.dday), rr.depth,'ko-');
ms(hh,4)
xlims = get(gca,'xlim')
hh=text(xlims(2) - .1, 100, 'PG, orig');
click_rgbk(hh,'c','r','s',12, 'ha','r')
hh=text(xlims(2) - .1, 200, 'PG, edited');
click_rgbk(hh,'c','k','s',12, 'ha','r')

%%%%%%%%%%%%%% plto masks %%%%%%%%%%%%%%%%%%%

f3;clf

rr.binmasks.bmask = rr.bmask;
titles = fieldnames(rr.binmasks);

cfg.abc_name = 'bins';
cfg.ord_name = 'index';
rr.index = [1:length(rr.dday)];
rr.fn =  isnan(rr.cuv);
aplotit(rr, config, 'fn', 'fn', ...
           'comment',  'original bad velocities', 'astitle',1,...           
           'cur_ax', subplot(4,3,1));

for ii=1:length(titles)
    cfg.abc_name = 'bins';
    cfg.ord_name = 'index';
    rr.fn =  getfield(rr.binmasks, titles{ii});
    if length(unique(rr.fn(:))) == 1
       subplot(4,3,ii+1)
       plot(rr.fn(1,:))
       title(titles{ii})
    else   
       aplotit(rr, config, 'fn', 'fn', ...
               'comment', titles{ii}, 'astitle',1,...           
               'cur_ax', subplot(4,3,ii+1));
    end
end
aplotit(rr, config, 'fn', 'hiamp',  'comment', 'hiamp', 'astitle', 1,...
        'cur_ax', subplot(4,3,ii+2));
subplot(4,3,11)
rr.flagged = (rr.instpflag~=0);
aplotit(rr, config, 'fn', 'flagged',  'comment', 'flagged', 'astitle', 1,...
        'cur_ax', subplot(4,3,ii+3));
subplot(4,3,ii+4)
plot(100*sum(rr.instpflag'==0)/length(rr.dday), rr.bins);ra(gca);
xl(0,100)




