function  write_editcfg(instclass, pingtype, filename, varargin);
%  write_editcfg(instclass, pingtype, filename, varargin);
% writes defaults to a file to be edited
% 
%  varargin: 
%   name                      value                         what
%  ---------                -------------              -------------
% 'verbose'                  [0 or 1]              write messages to screen 
%                                                  default is 1 (be verbose)
%

cfg.verbose = 1;
cfg = fillstruct(cfg, varargin);



if ~strcmp(filename(end-1:end), '.m')
   filename = [filename, '.m'];
end


tempfile = 'diary.tmp';
delete(tempfile);

fid = fopen(tempfile','a');
fprintf(fid, '\n\nparams.editcfg = get_pedefaults(%s, ''%s'');\n\n', ...
        inst2str(instclass), pingtype);
fclose(fid);


params.editcfg = get_pedefaults(instclass, pingtype)
diary(tempfile)
  params.editcfg
diary off



fid = fopen(tempfile,'r');
F = fread(fid);
s = char(F');
fclose(fid);



%% replace ":" with "="
ii = find(s == ':');
s(ii) = '=';


% find line breaks; use with printing
lineendi = find(F == 10);
line_startendi = [  [1; lineendi(1:end-1)+1]     [lineendi-1]];


if exist(filename)
   delete(filename)
end

ffid = fopen(filename,'w');
fprintf(ffid, '%%\n');
fprintf(ffid, '%%\n');

for linei = 1:(length(lineendi)-1)
   ii = line_startendi(linei,1) : line_startendi(linei,2);
   line = s(ii);
   fstr = findstr('get_pedefaults', line);
   if ~isempty(fstr)
      fprintf(ffid, '%% %s \n', line);
      break
   end
end
fprintf(ffid, '%%\n');
linenum = linei+3;   
for linei = [linenum+1: (length(lineendi)-1)]
   ii = line_startendi(linei,1) : line_startendi(linei,2);
   line = s(ii);
   fprintf(ffid,'%% %s \n', line);
end
fprintf(ffid, '\n');


fprintf(ffid, '\n\n%% copy lines from commented region above, and edit\n');
fprintf(ffid, '%% NOTES:\n');
fprintf(ffid, '%% all parameters should be fields of params.editcfg, eg.\n');
fprintf(ffid, '%% params.editcfg.weakprof_numbins = 2;\n');
fprintf(ffid, '%%----------------------------------------------\n');
fprintf(ffid, '\n');
fprintf(ffid, '\n');
fclose(ffid);



fprintf('\n\n===>   open file "%s" in an editor  <====\n', filename)
fprintf('====>   to change editing parameters <=====\n')








 






