%  This is a script
%  If you want to copy it to your local directory and modify it, 
%      help yourself.
%
% Run it by getting the configuration info, then the serial input info:
% cfg = get_uhdascfg('cfgbase','km0326');
% qcinfo = get_qcinfo(cfg);
%
% then type "lookat_serial"

start_end_tr = [];
for instnum = 1:length(qcinfo)
   trinfo = qcinfo(instnum).trinfo;
   start_end_tr = [start_end_tr; trinfo{1,2}; trinfo{end,2}];
end
startdd = min(start_end_tr(:,1));
enddd = max(start_end_tr(:,1));

dt = .5;

% plot heading
for dd = startdd : dt: enddd+.5
   ddrange = [dd dd+dt];
   plot_qc(qcinfo, 'heading', ddrange)
end
   
% plot latitude
for dd = startdd : dt: enddd+.5
   ddrange = [dd dd+dt];
   plot_qc(qcinfo, 'lat', ddrange)
end
   
% plot longitude
for dd = startdd : dt: enddd+.5
   ddrange = [dd dd+dt];
   plot_qc(qcinfo, 'lon', ddrange)
end
   
