function id = instrument_ids(instclass, incr)
%% get offsets for os or bb
if isa(instclass, 'os')
   id.header     = hex2dec('7f7f');
   id.flead      = 0 + incr;
   id.vlead      = hex2dec('0080') + incr;
   id.vel        = hex2dec('0100') + incr;
   id.cor        = hex2dec('0200') + incr;
   id.amp        = hex2dec('0300') + incr;
   id.pg         = hex2dec('0400') + incr;
   id.status     = hex2dec('0500') + incr; % Useless; ignore it.
   id.bt         = hex2dec('0600') + incr;
   % Added in STA and LTA files:
   id.nav        = hex2dec('2000');           % No separate nav type.
   id.fix_att    = hex2dec('3000');       % Or fixed attitude.
   id.var_att1   = hex2dec('30e0');
   id.var_att2   = hex2dec('30e8');
   id.var_att    = id.var_att1; % default: NP only
                             % other possibilities to be added.
else
   id.header     = hex2dec('7f7f');
   id.flead      = hex2dec('0000');
   id.vlead      = hex2dec('0080');          % 128
   id.vel        = hex2dec('0100');          % 256;
   id.cor        = hex2dec('0200');          % 512;
   id.amp        = 768;
   id.pg         = hex2dec('0400');          % 1024;
   id.bt         = 1536;
   id.nav        = 8192;
end

