function a_config = read_adpcfg(instclass, fid)
% a_config = read_adpcfg(instclass, fid)


if (nargin ~= 2)
   help(mfilename)
   error('requires 2 arguments')
end

start = ftell(fid);

vv = 0; 

a_config.configtype         = fread(fid, 1, 'char');          %  type      0x11                  
a_config.configver          = fread(fid, 1, 'char');          %  version   0x02                  
a_config.nbytes             = fread(fid, 1, 'int16');         %  bytes in configuration          
a_config.configtime         = read_date(instclass, fid, ftell(fid), 'DateTimeType'); %  date created or last modified    
a_config.npingsperbeam      = fread(fid, 1, 'int16');         %  consecutive pings for each beam 
a_config.sampinterval       = fread(fid, 1, 'int16');         %  samp interval in 16/(freq. trans) units
a_config.lag                = fread(fid, 1, 'int16');         %  samp spacing for autocorrelation
a_config.pulselength        = fread(fid, 1, 'int16')/100;     %  in cm (along profiling axis )   
a_config.reclength          = fread(fid, 1, 'int16')/100;     %  in cm receiver recovery delay   
a_config.minblanklength     = fread(fid, 1, 'int16')/100;     %  in cm blank to first bin        
a_config.operatingrange     = fread(fid, 1, 'int16');         %  max range in m                  
a_config.pingdelay          = fread(fid, 1, 'int16');         %  in m  delay befor next ping     
a_config.autofilter         = fread(fid, 1, 'int16');         %  0-fixed filter; 1-auto filter   
a_config.filtera            = fread(fid, [1 2], 'int16');     %  fixed filter coefficients filtera
a_config.filterb            = fread(fid, [1 2], 'int16');     %  fixed filter coefficients filterb
a_config.fastping           = fread(fid, 1, 'char');          %  if 1 disable pingdelay          
a_config.spare              = fread(fid, [1 25], 'char');     %  set to all 0s  

if (vv), ftell(fid) , end                 %%% offset 96+64: --------

