function tt = read_date(instclass, fid, start, struct_name)
%tt = read_date(instclass, fid, start, struct_name)
% sontek date structure reader

if (nargin ~= 4)
   help(mfilename)
   error('requires 4 arguments')
end


fseek(fid, start, 'bof');

if (strcmp(struct_name, 'DateTimeType'))
   tt = [NaN NaN NaN NaN NaN NaN];
   tt(1)  = fread(fid, 1, 'int16');       % year
   tt(3)  = fread(fid, 1, 'int8');        % day
   tt(2)  = fread(fid, 1, 'int8');        % month
   tt(5)  = fread(fid, 1, 'int8');        % minute
   tt(4)  = fread(fid, 1, 'int8');        % hour
   tt(6) =  fread(fid, 1, 'int8')/100+ fread(fid, 1, 'int8');   %sec100/100 + second

elseif (strcmp(struct_name, 'DateType'))
   tt.year = fread(fid, 1, 'int16');  
   tt.day = fread(fid, 1, 'int8');   
   tt.month = fread(fid, 1, 'int8');   
else
   error('structure name must be "DateTimeType" or "DateType"')
end
