function u_config = read_usercfg(instclass, fid)
%u_config = read_usercfg(instclass, fid)


if (nargin ~= 2)
   help(mfilename)
   error('requires 2 arguments')
end

start = ftell(fid);

vv = 0; 

u_config.configtype              = fread(fid, 1, 'uchar');     %  type      0x12                   
u_config.configver               = fread(fid, 1, 'uchar');     %  version   0x01                   
u_config.nbytes                  = fread(fid, 1, 'uint16');    %  bytes in configuration           
u_config.configtime = read_date(instclass, fid, ...
              ftell(fid), 'DateTimeType');                     %  date created or last modified    
u_config.temp                    = fread(fid, 1, 'int16')/10;  %  0.1 deg c (now deg)
u_config.sal                     = fread(fid, 1, 'int16')/10;  %  0.1 ppt   (now ppt)
u_config.cw                      = fread(fid, 1, 'int16')/10;  %  0.1 m/s   (now m/s)              
u_config.ncells                  = fread(fid, 1, 'uint16');    %  # of depth cells in profile      
u_config.cellsize                = fread(fid, 1, 'uint16')/100;%  in cm     (now m)                  
u_config.blankdistance           = fread(fid, 1, 'uint16')/100;%  in cm     (now m)                    
if (vv), ftell(fid), end           %%%%%%--------  %  offset 24 +96+64


u_config.sensordepth             = fread(fid, 1, 'long')/100;  %  in cm  (pc ver only) (now m)
u_config.tempmode                = fread(fid, 1, 'char');      %  0- user value  1- measured       
if (vv), ftell(fid), end           %%%%%%%---------- offset 29+  96+64

u_config.avginterval             = fread(fid, 1, 'uint16');    %  in s                    
u_config.profileinterval         = fread(fid, 1, 'uint16');    %  in s                    
u_config.pinginterval            = fread(fid, 1, 'uint16')/10; %  in 0.1 s                
u_config.burstmode               = fread(fid, 1, 'uint16');    %  0-disabled; 1-enabled   
u_config.burstinterval           = fread(fid, 1, 'uint16');    %  in s                    
u_config.profilesperburst        = fread(fid, 1, 'uint16');    %  number
if (vv), ftell(fid), end           %%%%%%%% ----------  offset 41  +96+64

u_config.coordsystem             = fread(fid, 1, 'char');      %  0-beam;     1-xyz; 2-enu         
u_config.outmode                 = fread(fid, 1, 'char');      %  0-auto;     1-polled             
u_config.outformat               = fread(fid, 1, 'char');      %  0-binary;   1-ascii              
u_config.recorderenabled         = fread(fid, 1, 'char');      %  0-disabled; 1-enabled            
u_config.recordermode            = fread(fid, 1, 'char');      %  0-normal mode; 1-buffer mode     
u_config.deploymentmode          = fread(fid, 1, 'char');      %  0-disabled; 1-enabled    
u_config.deploymentname          = fread(fid, [1 9], 'char');  %  dir name in recorder     
if (vv), ftell(fid), end                 %%%%%%%%-------  offset 56  +96+64

u_config.begindeploymentdatetime =  read_date(instclass, fid, ...       % 
              ftell(fid), 'DateTimeType');  
u_config.commentline1        = fread(fid, [1 60], 'char');      % comment line 1, 60 char
u_config.commentline2        = fread(fid, [1 60], 'char');      % comment line 1, 60 char
u_config.commentline3        = fread(fid, [1 60], 'char');      % comment line 1, 60 char
u_config.autosleep                   = fread(fid, 1, 'char');      %sav power
u_config.spare               = fread(fid, [1  11], 'char');      %  set to all 0s                    

if (vv), ftell(fid), end                   %%%%%%------ 256+ 96+64

