
%%%%%%%%%%%%%%%%%%%%% raw logging %%%%%%%%%%%%%%%%%%

%% cruise configuration file template, used by cruisesetup.py
%% to write  km0413acfg.m

%% Things marked with arrows may change if the installation
%% changes; this may be automated later, but for now it must
%% be done manually.

%% these variables are used by quick_adcp.py


yearbase = 2004;               % yearbase
cruiseid = 'km0413a';             % a title string, cruise designation
uhdas_dir = '/home/data/km0413a';   % root for dirs: raw, rbin, gbin, proc

%% startcruise.py should get instrument names from config/sensor_cfg.py

all_instping = ...
  {'os38', 'bb';
   'os38', 'nb'};


%%              directory    extension   extension
%%                           to read     to write

%% 2004/06/05 : take pcode out of the list until we have it again
%msg_info = {'pcode' ,    'gps',      'gps',     %% position from pcode
%             'gyro'  ,    'hdg',      'hdg',     %% gyro heading
%             'adu2',      'adu',      'adu',     %% heading from adu
%             'posmv',     'pmv',      'pmv',    %% heading from posmv
%             'adu2',      'gps',      'gps',     %% positions from adu
%             'posmv',     'gps',      'gps'};    %% positions from posmv
%%

msg_info = {'gyro'  ,    'hdg',      'hdg',      %% gyro heading
             'adu2',      'adu',      'adu',     %% heading from adu
             'posmv',     'pmv',      'pmv',     %% heading from posmv
             'adu2',      'gps',      'gps',     %% positions from adu
             'posmv',     'gps',      'gps'};    %% positions from posmv


%% write the rules.
%% Only include the fields with values; they must be IN ORDER

best.rules = {'gps', 'heading', 'pitch', 'roll', 'heave'};

%% rules for fields that have rules
%%                                                         (rule)
%%                  directory       rbin_suffix        reference_to

%% 2004/06/05 : until pcode comes back
%best.gps_rule  =    {'pcode',         'gps'};              %%best is pcode
%
best.gps_rule  =    {'posmv',          'gps'};              %%best is posmv
best.heading_rule = {  'gyro',         'hdg'};
best.pitch_rule =   { 'posmv',         'pmv'};
best.roll_rule  =   { 'posmv',         'pmv'};
best.heave_rule  =   { 'posmv',        'pmv'};

timebase = 'log';                                %% choose 'log' for linux pc
                                                 %%     or 'gga' for gga

% set full paths to raw  bin, gbin, and processing  directories
rawdir   =  '/home/data/km0413a/raw';
rbindir  =  '/home/data/km0413a/rbin';

% directory to write processing log files
logfpath  =  '/home/data/km0413a/proc/proclog';


%%%%%%%%%%%%%%%%%% processing (quick_adcp.py) %%%%%%%%%%%%%%%%%%

gbindirbase  =  '/home/data/km0413a/gbin';    %<--
         %contains son125, os38b, os38n for gbin subdirs (time, best...)






