% set parameters used for logging
% first field is the same as the raw logging directory (eg. os38)
% second field is the ping type (in case of interleaved pings)
%% parsed  manually or by running
%  cruise_proc; params = get_params(allparams, 'os38', 'nb');

pp.ducer_depth  = 8;        

%---------------------------------
%% sontek 125KHz 
% processing  sources:

p.h_align      = -1.3;     
p.velscale     = 1.0;      
p.interval     = 300;      
p.ilayer       = 2:6;      
p.beamangle    = 33;       

p=fillstruct(p,pp,1);
allparams.son125.son = p; clear p

%---------------------------------
%% OS38, first pings
% processing  sources:
p.h_align      = 43.8; 
p.velscale     = 1.0;
p.interval     = 300;     
p.ilayer       = 3:30;

p=fillstruct(p,pp,1);
allparams.os38.first = p; clear p

%---------------------------------
%% OS38, BB pings
% processing  sources:
p.h_align      = 43.8; 
p.velscale     = 1.0;
p.interval     = 300;     
p.ilayer       = 5:20;

p=fillstruct(p,pp,1);
allparams.os38.bb = p; clear p

%---------------------------------
%% OS38, NB pings
% processing  sources:
p.h_align      = 43.8; 
p.velscale     = 1.0;
p.interval     = 300;     
p.ilayer       = 3:40;

p=fillstruct(p,pp,1);
allparams.os38.nb = p; clear p

clear pp
