%% DO NOT DELETE!!!
%% script called by nb_plotnb 


if ~isemptys(cfg.otherheading)
   if ~iscell(cfg.otherheading)
      fprintf('otherheading must be a cellarray \')
      fprintf('  with instrument and extension, such as:\n')
      fprintf(' {''posmv'',''pmv''} \n')
      return
   elseif length(cfg.otherheading) ~= 2
      fprintf('otherheading must be a cellarray \')
      fprintf('  with instrument and extension, such as:\n')
      fprintf(' {''posmv'',''pmv''} \n')
      return
   end      
   otheri = find(ismember(cfg.path_ext(:,1),  cfg.otherheading{1}) & ...
                 ismember(cfg.path_ext(:,2),  cfg.otherheading{2}));
   h_path = cfg.path_ext{otheri,1};
   h_ext  = cfg.path_ext{otheri,2};
   
   %% bbdd has a struct like bbdd.posmv with:
   %%    bbdd.posmv.pmv.gdata (data from read_bin)
   %%    bbdd.posmv.pmv.gstruct (structure from read_bin)
   inststruct = getfield(nbdd, h_path);
   extstruct  = getfield(inststruct, h_ext);
   hdata = getfield(extstruct, 'gdata');
   hstruct = getfield(extstruct, 'gstruct');
   %% get quality info
   qcmask = qc_rbin(hdata, hstruct);
   hdata = hdata(r_row(hstruct, 'heading'),:);
   hmask = qcmask(r_row(hstruct, 'heading'),:);

   dhdeg = mstdgap(hdata(~hmask) - nbdd.heading(~hmask));
   mean_headcor_rad = pi*dhdeg/180;
else
   mean_headcor_rad = 0;
   dhdeg = 0;
end

vels = [];

%%%%%%%%%%5%% edit nb pings and average  %%%%%%%%%%%%%%%

if nbOK
   
   nbparams = cfg.params;
   nbparams.editcfg = get_pedefaults(nb, 'nb');
   nbparams.use_refavg = 1;
   nbparams.pingedit = 'all';
   
   fprintf('rotating measured velocities by exp(-i*%f) deg\n', mstdgap(dhdeg))
   cuv = exp(-i*mean_headcor_rad)*(nbdd.umeas + i* nbdd.vmeas);
   nbdd.umeas = real(cuv);
   nbdd.vmeas = imag(cuv);
   ushipM = repmat(nbdd.uship, length(nbdd.depth),1);
   vshipM = repmat(nbdd.vship, length(nbdd.depth),1);
   
   nba = cutadcp(nbdd,1);
   [nbavg_edit, nbmasks] = avg(nb, nbdd, nba, nbparams);
   uabs = 100*(ushipM + real(nbdd.umeas.*dotmmask(nbmasks.instpflag)));
   vabs = 100*(vshipM + real(nbdd.vmeas.*dotmmask(nbmasks.instpflag)));
   nbavg_edit.uabs = mstdgap(uabs')';
   nbavg_edit.vabs = mstdgap(vabs')';

   % not pingedited
   nbparams.pingedit = 'none';
   [nbavg_noedit] = avg(nb, nbdd, nba, nbparams);
   uabs = 100*(ushipM + real(nbdd.umeas));
   vabs = 100*(vshipM + real(nbdd.vmeas));
   nbavg_noedit.uabs = mstdgap(uabs')';
   nbavg_noedit.vabs = mstdgap(vabs')';
   
   
   vels.nb_uabs = nbavg_noedit.uabs;
   vels.nb_vabs = nbavg_noedit.vabs;

   nb_goodi = find(nbavg_edit.pg(:,4) > 20);
   nb_ngoodi = find(nbavg_noedit.pg(:,4) > 20);
   
   nbgoodmask = nbavg_edit.pg(:,4) > 20;
   
end

