%% DO NOT DELETE!!!
%% called by os_plotbbnb and plotgrayscale.m

if ~isemptys(cfg.otherheading)
   if ~iscell(cfg.otherheading)
      fprintf('otherheading must be a cellarray \')
      fprintf('  with instrument and extension, such as:\n')
      fprintf(' {''posmv'',''pmv''} \n')
      return
   elseif length(cfg.otherheading) ~= 2
      fprintf('otherheading must be a cellarray \')
      fprintf('  with instrument and extension, such as:\n')
      fprintf(' {''posmv'',''pmv''} \n')
      return
   end      
   otheri = find(ismember(cfg.path_ext(:,1),  cfg.otherheading{1}) & ...
                 ismember(cfg.path_ext(:,2),  cfg.otherheading{2}));
   h_path = cfg.path_ext{otheri,1};
   h_ext  = cfg.path_ext{otheri,2};
   
   %% bbdd has a struct like bbdd.posmv with:
   %%    bbdd.posmv.pmv.gdata (data from read_bin)
   %%    bbdd.posmv.pmv.gstruct (structure from read_bin)


   if bbOK
      if isfield(bbdd, h_path)
         inststruct = getfield(bbdd, h_path);
      else
         inststruct = [];
      end
   end
   if nbOK
      if isfield(nbdd, h_path)
         inststruct = getfield(nbdd, h_path);
      else
         inststruct = [];
      end
   end

   try
      extstruct  = getfield(inststruct, h_ext);
      hdata = getfield(extstruct, 'gdata');
      hstruct = getfield(extstruct, 'gstruct');
      %% get quality info
      qcmask = qc_rbin(hdata, hstruct);
      hdata = hdata(r_row(hstruct, 'heading'),:);
      hmask = qcmask(r_row(hstruct, 'heading'),:);
      
      if bbOK
         dhdeg = mstdgap(hdata(~hmask) - bbdd.heading(~hmask));
      else
         dhdeg = mstdgap(hdata(~hmask) - nbdd.heading(~hmask));
      end      
      mean_headcor_rad = pi*dhdeg/180;
   catch
      mean_headcor_rad = 0;
      dhdeg = 0;
   end
else
   mean_headcor_rad = 0;
   dhdeg = 0;
end

vels = [];


%%%%%%%%%%5%% edit bb pings and average  %%%%%%%%%%%%%%%
if bbOK

   
   bbparams = cfg.params;
   bbparams.editcfg = get_pedefaults(os, 'bb');
   bbparams.use_refavg = 1;
   bbparams.pingedit = 'all';
   
   fprintf('rotating measured velocities by exp(-i*%f) deg\n', mstdgap(dhdeg))
           
   cuv = exp(-i*mean_headcor_rad)*(bbdd.umeas + i* bbdd.vmeas);
   bbdd.umeas = real(cuv);
   bbdd.vmeas = imag(cuv);
   ushipM = repmat(bbdd.uship, length(bbdd.depth),1);
   vshipM = repmat(bbdd.vship, length(bbdd.depth),1);

   
   bba = cutadcp(bbdd,1);
   [bbavg_edit, bbmasks] = avg(os, bbdd, bba, bbparams);
   uabs = 100*(ushipM + real(bbdd.umeas.*dotmmask(bbmasks.instpflag)));
   vabs = 100*(vshipM + real(bbdd.vmeas.*dotmmask(bbmasks.instpflag)));
   bbavg_edit.uabs = mstdgap(uabs')';
   bbavg_edit.vabs = mstdgap(vabs')';

   % not pingedited
   bbparams.pingedit = 'none';
   [bbavg_noedit] = avg(os, bbdd, bba, bbparams);
   uabs = 100*(ushipM + real(bbdd.umeas));
   vabs = 100*(vshipM + real(bbdd.vmeas));
   bbavg_noedit.uabs = mstdgap(uabs')';
   bbavg_noedit.vabs = mstdgap(vabs')';

  
   vels.bb_uabs = bbavg_noedit.uabs;
   vels.bb_vabs = bbavg_noedit.vabs;
 
   
   bb_goodi = find(bbavg_edit.pg(:,4) > 20);
   bb_ngoodi = find(bbavg_noedit.pg(:,4) > 20);

   bbgoodmask = bbavg_edit.pg(:,4) > 20;

end

%%%%%%%%%%5%% edit nb pings and average  %%%%%%%%%%%%%%%

if nbOK
   
   nbparams = cfg.params;
   nbparams.editcfg = get_pedefaults(os, 'nb');
   nbparams.use_refavg = 1;
   nbparams.pingedit = 'all';
   
   fprintf('rotating measured velocities by exp(-i*%f) deg\n', mstdgap(dhdeg))
   cuv = exp(-i*mean_headcor_rad)*(nbdd.umeas + i* nbdd.vmeas);
   nbdd.umeas = real(cuv);
   nbdd.vmeas = imag(cuv);
   ushipM = repmat(nbdd.uship, length(nbdd.depth),1);
   vshipM = repmat(nbdd.vship, length(nbdd.depth),1);
   
   nba = cutadcp(nbdd,1);
   [nbavg_edit, nbmasks] = avg(os, nbdd, nba, nbparams);
   uabs = 100*(ushipM + real(nbdd.umeas.*dotmmask(nbmasks.instpflag)));
   vabs = 100*(vshipM + real(nbdd.vmeas.*dotmmask(nbmasks.instpflag)));
   nbavg_edit.uabs = mstdgap(uabs')';
   nbavg_edit.vabs = mstdgap(vabs')';

   % not pingedited
   nbparams.pingedit = 'none';
   [nbavg_noedit] = avg(os, nbdd, nba, nbparams);
   uabs = 100*(ushipM + real(nbdd.umeas));
   vabs = 100*(vshipM + real(nbdd.vmeas));
   nbavg_noedit.uabs = mstdgap(uabs')';
   nbavg_noedit.vabs = mstdgap(vabs')';
   
   
   vels.nb_uabs = nbavg_noedit.uabs;
   vels.nb_vabs = nbavg_noedit.vabs;

   nb_goodi = find(nbavg_edit.pg(:,4) > 20);
   nb_ngoodi = find(nbavg_noedit.pg(:,4) > 20);
   
   nbgoodmask = nbavg_edit.pg(:,4) > 20;
   
end

