fprintf('this program should either be rewritten to match the \n')
fprintf('/home/adcp/plots/run_autovect.m --> $prog/matlab/utils/autovect.m\n')
fprintf(['/home/adcp/plots/run_autocont.m --> $prog/matlab/utils/autocont.m\n')
return



%% function data = run_autopanel(varargin)


% data = run_autopanel(varargin)
% makes a 2-panel plot of amplitude and spectral width from raw ADCP data
% very little error checking
% does not concatenate files (reads only what is available in most recent file)
% 
% options are:
%
%    num_mins   [float]           % default (15) plot this many minutes 
%    numpts   [integer]           % number of pings to get (default 600)
%                                 %      numpts overrides num_mins if chosen
%                                 % default is 600pts.  capped at 1000.
%    rawdir   find raw files here % '/mnt/peale1/raw/adcp_pings';
%    figdir   put figure here     % default  '.'
%    outfile   output file base   % 'amp_sw'  (saved as amp_sw.jpg)
%                                 %  (if no arguments at all, not saved)
%    firstdepth  (z starts here)  %              31;
%    beam       [1-4]             %      default(1)
%    cruisesid  [string]          % optional
%    comment    [string]          %optional (goes into titlestr)

if (nargin == 0)
   saveplot = 0;
else
   saveplot = 1;
end

maxnumpings = 1000;  
%%%

cfg.num_mins   = [];
cfg.numpts     =[];
cfg.rawdir     = '/home/data/adcp/raw/adcp_pings';
cfg.figdir     =  '.';
cfg.outfile    = 'amp_sw';
cfg.firstdepth = 31;
cfg.prefix     = 'rb';
cfg.beam       = 1;
cfg.cruiseid  = '';
cfg.comment    = '';

cfg = fillstruct(cfg, varargin, 0);


if (~isemptys(cfg.cruiseid))
   titlestr = cfg.cruiseid;
else
   titlestr = '';
end

if (~isemptys(cfg.comment))
   titlestr = sprintf('%s (%s)', titlestr, cfg.comment)
end

%get yearbase
globstr = sprintf('%s*.raw', cfg.prefix);
filelist = dir(fullfile(cfg.rawdir, globstr));
rawfile =  filelist(end).name;
fullrawfile = fullfile(cfg.rawdir, rawfile);
yearbase = str2num(rawfile(4:7));
datatest = read(nb, fullrawfile, 'yearbase', yearbase, 'ends', 2);
lasti = datatest.info.ilist(2);
if (~isemptys(cfg.num_mins))
numpings = round(cfg.num_mins * ...
                 (diff(datatest.info.ilist))/(diff(datatest.dday)*24*60));
elseif (isemptys(cfg.numpts))
   numpings = 600;
else
   numpings = cfg.numpts;
end

numpings = min(numpings, maxnumpings);

ilist = [lasti - numpings : lasti];

data = read(nb, datatest.info, 'yearbase', yearbase, 'ilist', ...
           ilist, 'vars','all');
[data, config] = restruct(nb, data);

data.mins = 24*60*(data.dday - data.dday(end));
config.abc_name = 'mins';
config.xlim = [data.mins(1) data.mins(end)];

data.depth = ([1:length(data.bins)]-1)*8 + cfg.firstdepth;
config.ord_name = 'depth';

%plot velocities
clf;whitebg('w')
cfgout = aplotit(data, config, 'cur_ax', subplot(2,1,1),'fn', ...
                 sprintf('amp%d', cfg.beam));
axes(cfgout.cur_ax);
ylabel('depth (m)')

cfgout =aplotit(data, config, 'cur_ax', subplot(2,1,2),'fn', ...
                sprintf('sw%d', cfg.beam));
axes(cfgout.cur_ax)
xlabel('minutes before present')
ylabel('depth (m)')


ymdhms = clock;
datestr = to_date(yearbase, to_day(yearbase, ymdhms) ,'s');
titlestr = sprintf('%s  data immediately preceding %s Z', titlestr, datestr);

orient portrait
subtitle(titlestr, 'portrait')
date_it


if (saveplot)
   filenamebase = sprintf('%s/%s', cfg.figdir, cfg.outfile)
   print(gcf, '-dpsc', filenamebase)
   %gsconvert(filenamebase, 'ps', 'jpg')
   eval(sprintf('!gsconvert.py %s.ps %s.jpg\n', filenamebase, filenamebase))
end


