function changed = chk_rconfig(config1, config2)
%  changed = chk_rconfig(config1, config2)
% compare two structures.  return  0 if no diff, 1 if some diff

changed = 0;

%ascii field
if ~strcmp(config1.coordsystem, config1.coordsystem)
   changed = 1;
   fprintf('coordinate system changed\n')
   fprintf('old  (%d), new  (%d)\n',...
           getfield(config1, 'coordsystem'), getfield(config2,'coordsystem'))
   return
end


%numeric fields
fields = {...
   'yearbase',...
   'ncells',...
   'cell',...
   'blank',...
   'pulse',...
   'head_align',...
   'head_bias',...
   'bt_was_on'};


for fn = 1:length(fields)
   if (round(getfield(config1, fields{fn})) ~= ...
       round(getfield(config2, fields{fn})))
      changed = 1;
      fprintf('configuration changed\n')
      fprintf('old %s (%d), new %s (%d)\n',...
              fields{fn}, round(getfield(config1, fields{fn})),...
              fields{fn}, round(getfield(config2, fields{fn})))
      return
   end
end

   

 



