function fix_vmdastimes(filelist, showverbose)
%  TWITS.
% fix_vmdastimes(filelist, showverbose) runs through the filelist of
% rbin files  and fixes the u_dday timestamps
% At the moment it remakes sec_pc_minus_utc into something 
% reasonable and rewrites the file.
%
% filelist is from dirs.
% showverbose: plot it

% JH 2004/1/3. crude. getting desperate


if nargin == 1
   showverbose = 0;
else
   showverbose = 1;
end



for ifile=1:length(filelist)

   filename = filelist(ifile).name
   [rr,rs]=read_bin(filename);
   fclose(rs.fid);
   if ismember('orig_sec_pc_minus_utc',rs.rows)
      fprintf('not processing file %s, already corrected\n', filename)
   else
      u_dday = rr(r_row(rs,'u_dday'),:);
      ens_num = rr(r_row(rs,'ens_num'),:);
      if showverbose
         clf
         subplot(211)
         plot(ens_num,u_dday,'r.-')
         title(filename)
         hold on
      end      
      orig_sec_pc_minus_utc = rr(r_row(rs,'sec_pc_minus_utc'),:);
      % get the original PC time; 
      pc_dday = u_dday + orig_sec_pc_minus_utc/86400;
      % correct it by the median of sec_pc_minus_utc since that can have errors
      % (somewhat risky -- requires under half to be good)
      sec_pc_minus_utc = repmat(median(orig_sec_pc_minus_utc), ...
                                1, length(u_dday));
      u_dday = pc_dday - sec_pc_minus_utc/86400;
      
      if showverbose
         plot(ens_num,u_dday, 'k')
         subplot(212)
         plot(ens_num,orig_sec_pc_minus_utc)
         hold on
         plot(ens_num,sec_pc_minus_utc,'k')       
         paused
      end
      
      rr(r_row(rs,'u_dday'),:) = u_dday;
      rr(r_row(rs,'sec_pc_minus_utc'),:) = sec_pc_minus_utc;
      rr = [rr;orig_sec_pc_minus_utc];
      rownames = rs.rows;
      rownames{end+1} = 'orig_sec_pc_minus_utc';
      write_bin(filename, rr, 'rownames',rownames);
   end
end
