% define file names

logfile = fullfile(ldcodas_path,    [blkbase_str  '.log'])  ;
cmdfile = fullfile(ldcodas_path,    [blkbase_str  '.cmd'])  ;           
binfile = fullfile(ldcodas_path,    [blkbase_str  '.bin'])  ;          
nav1file = fullfile(ldcodas_path,   [blkbase_str  '.gps1']) ;         
nav2file = fullfile(ldcodas_path,   [blkbase_str  '.gps2']) ;        


%% open if not exist or not open

if ( ~exist('fid_log') |   (exist('fid_log')  & ((fid_log==0)  | isempty(fid_log))  ))
   fid_log  = fopen(logfile,  'a') ;
end

if (~exist('fid_nav1') |  (exist('fid_nav1') & ((fid_nav1==0) | isempty(fid_nav1))  ))
   fid_nav1 = fopen(nav1file, 'a') ;
end

if (~exist('fid_nav2') |  (exist('fid_nav2') & ((fid_nav2==0) | isempty(fid_nav2))  ))
   fid_nav2 = fopen(nav2file, 'a') ;
end

if (~exist('fid_cmd')  |  (exist('fid_cmd')  & ((fid_cmd==0)  | isempty(fid_cmd))  ))
   fid_cmd  = fopen(cmdfile,  'a') ;
end

if (~exist('fid_bin')  |  (exist('fid_bin')  & ((fid_bin==0)  | isempty(fid_bin))  ))
   fid_bin  = fopen(binfile,  'a') ;
end

%%%%% return if can't open


if fid_log  == -1
   error(['Can''t open ', logfile]);   
   return, 
end           

if fid_nav1 == -1
   error(['Can''t open ', nav1file]); 
   return, 
end           

if fid_nav2 == -1
   error(['Can''t open ', nav2file]); 
   return, 
end           

if fid_cmd  == -1
   error(['Can''t open ', cmdfile]);   
   return, 
end           

if fid_bin  == -1
   error(['Can''t open ', binfile]);   
   return, 
end           


