function last_ensinfo = get_last_ensinfo(instclass, rawdir, rawbaselist)
%%  last_ensinfo = get_last_ensinfo(instclass, rawdir)
%%  assumes blk info in files globbed created as 'ens_blk%03d.log'
%%   info from last ens created from blkbase_str.log
%%
%%   (controlled by write_blk.m)   (controlled by get_next_ens)
%%   --------------------------     ----------------------
%                                       lastens
%                                        blknum
%             profnum
%                                       ifile
%                                       rawfilebase
%                                       blkbase_str


%%% clean up if there was a bad group

blklist = dirs('ens_blk*.log');
if length(blklist) > 0
   lastblkbase = blklist(end).name(1:10)
   lastblks = dirs(sprintf('%s.*', lastblkbase));
   lastblockOK = 1;
   for ifile = 1:length(lastblks)
      if lastblks(ifile).bytes == 0
         lastblockOK = 0;
         break
      end
   end
   
   if ~lastblockOK
      fprintf('%s group is bad: deleting.', lastblkbase)
      for ifile = 1:length(lastblks)
         delete(lastblks(ifile).name)
      end
   end
end
%%%%%%%%%%%%%%

%assume all existing files are OK

blklist = dirs('ens_blk*.log');
%this only happens when starting a new database
if (length(blklist) == 0)
   filenum = 0;
   % in case we start with an empty log file, skip until we find one.
   while (1)
      filenum = filenum+1;
      rawlogfile = fullfile(rawdir, [rawbaselist{filenum}, '.raw.log']);
      % get raw logfile info
      [rlog_udday, rlog_offsets, rlog_bytes, rlog_ensnums, rlog_instdday] = ...
          textread( rawlogfile, '%f%d%d%d%f');
      if length(rlog_ensnums) > 0
         %----------------------------  %  1-based numbers 
         last_ensinfo.lastens     =  rlog_ensnums(1);  
         last_ensinfo.ifile       =  1;
         last_ensinfo.blknum      =  1;
         %----------------------------  % preset 0-based
         last_ensinfo.profnum     = -1; 
         %----------------------------  % 
         last_ensinfo.rawfilebase = rawbaselist{1};
         last_ensinfo.blkbase_str = sprintf('ens_blk%03d', last_ensinfo.blknum);
         last_ensinfo.newdb       = 1;
         return
      end
   end
end

% otherwise: THIS IS INCREDIBLY UGLY!  There has to be a better way...
% parse the last line of the last log file to get rawfilebase, lastens etc
logfile = blklist(end).name;
fid = fopen(logfile, 'r');
while 1
   tline = fgetl(fid);
   if ischar(tline),
      line = tline;
   else
      break
   end
end
fclose(fid);

need_to_parse = sscanf(line, '%s %d %d %d ');
rawfilebase        = char(need_to_parse(1:end-3))';
lastens            =      need_to_parse(end-2);
numsecs_in_profile  =      need_to_parse(end-1);
profnum            =      need_to_parse(end);


[junk, blkbase_str] = fileparts(logfile);


last_ensinfo.lastens      = lastens;
last_ensinfo.blknum       = str2num(blkbase_str(8:10));
last_ensinfo.profnum      = profnum;
last_ensinfo.ifile        = find(ismember(rawbaselist, rawfilebase));
last_ensinfo.rawfilebase  = rawfilebase;
last_ensinfo.blkbase_str  = blkbase_str;
last_ensinfo.newdb        = 0;


