function dbinfo = setup_dbinfo(rawdir, last_ensinfo, params)


rawfilebase = last_ensinfo.rawfilebase;

rawfile = fullfile(rawdir, [rawfilebase '.raw']); 

pingtypes = get_pingtypes(params.instclass, rawdir, rawfilebase, params);


if isa(params.instclass, 'os')
   data = read(params.instclass, rawfile, 'yearbase', params.yearbase, ...
               'ilist', 1, 'second_set',  pingtypes.second_set);
else
   data = read(params.instclass, rawfile, 'yearbase', params.yearbase, ...
               'ilist', 1);
end   



data.config.tr_pressure          = data.config.tr_pressure + params.ducer_depth;
data.depth                       = data.config.tr_pressure + data.depth;
NC                               = data.config.ncells;
data.ens_threshold               = 0;
data.ev_threshold                = params.editcfg.error_velocity_cutoff;
data.top_ref_bin                 = params.editcfg.rl_bins(1);
data.bot_ref_bin                 = params.editcfg.rl_bins(end);
config1                          = mk_config1(data);
c1_index                         =  config1_ind;
config1(c1_index.avg_interval)   = params.interval;
config1(c1_index.hd_offset)      = params.h_align;
config1(c1_index.heading_bias)   = 0;  %% deal with this in h_align.
access                           = mk_access(data);    % Doesn't change.


dbinfo.config1 = config1;
dbinfo.access = access;
dbinfo.depth = data.depth;