function cf_color(h, clev, i0)
% function cf_color(h, clev, i0)
%
% OBSOLETE: replaced by cdata_direct.m
%
% Converts a plot made by contourf or m_contourf to
% indexed colors ('CDataMapping', 'direct').
%
% Inputs:
%   h     Handle of patch object made by contourf;
%            this is the second output argument of contourf.
%   clev  Vector of contour levels (boundaries) *used* in
%             the call to contourf.  It should start and
%             end with extremes, so that all data fall
%             within its limits.
%   i0    Index in the colormap where the first range in
%             clev will fall.  Optional; default is 1.
%             Other values are used to pick a section of
%             a concatenated colormap.
%         Or, if i0 is a vector, it will be interpreted
%             directly as the set of indices in the colormap
%             that correspond to the ranges in clev.  In
%             this case, you must have
%             length(i0) = length(clev) - 1
%
% See also: indfcbar, a companion routine to make a colorbar
%             using the same indexing scheme.
%
% EF 2001/10/09
%



disp('Warning: cf_color is obsolete.  Please use cdata_direct.')

if nargin < 2,
   error('Need at least 2 arguments.');
end
if nargin == 2,
   i0 = 1;
end

nlev = length(clev);
if length(i0) == 1,
   indices = (i0 - 1) + (1:(nlev-1));
elseif length(i0) == (nlev-1),
   indices = i0;
else
   help cf_color
   error('length of i0 must be either 1 or length(clev)-1')
end

lev_ca = get(h, 'CData');
% Change cell array into regular array.
lev = zeros(size(lev_ca));
for ii = 1:length(lev)
   lev(ii) = lev_ca{ii};
end

for ilev = 1:(nlev-1)
   ii = find(lev < clev(ilev+1) & lev >= clev(ilev));
   if ~isempty(ii)
      set(h(ii), 'CData', indices(ilev));
   end
end
ii = find(lev >= clev(nlev));
if ~isempty(ii)
   set(h(ii), 'CData', indices(end));
   disp('Warning: data were found outside the range of clev.');
   disp(' They are being assigned the last color index.');
end

set(h,'CDataMapping','direct');

