function uniq_plot(xM, yM, varargin);
% uniq_plot(xM, yM, varargin)
%
% make your plot take up less disk space!!!
%
% starting with two big masked matrices (xM and yM), screen for repetitions
%        and only plot unique pairs.  
% USAGE NOTE: Don't use with float data: probably no repetitions.  But you 
%        could resolve to granularity and use this
% Then print with "-painters" 
% 
% varargin is name, value pairs as:
%
%  [name]                 [default]
%  marker                    '.'                      marker marker
%  color                     'g'                      marker color
%  msize                     4                        marker size
%





cfg.marker = '.';
cfg.color = 'b';
cfg.msize = 6;


xy = xM(:) + i*yM(:);


cfg = fillstruct(cfg, varargin, 0);

plot(unique(xy),'linestyle', 'none',...
     'marker', cfg.marker, 'color', cfg.color, 'markersize', cfg.msize);
