#!/usr/bin/env python

"""
Convert a gif animation to fli/flc animation.

Usage: gif2fli.py gifmovie flcmovie
   where gifmovie and flcmovie are the names of the input and
   output files.

"""

import os, sys, tempfile

def pixels(gif):
   f = os.popen('file ' + gif).readline()
   ff = f.split()
   return ff[-3], ff[-1]



def convert(gifmovie, flcmovie):
   prefix = tempfile.mktemp()
   filelist = '%s_.lst' % prefix
   try:
      cmd = 'gifsicle -e --output %(prefix)s %(gifmovie)s' % vars()
      print cmd
      os.system(cmd)
      names = os.popen('/bin/ls %s.*' % prefix).readlines()
      file(filelist, 'w').writelines(names)

      nx, ny = pixels(names[0].strip())
      res_opt = '-g ' + nx + 'x' + ny

      cmd = 'ppm2fli +f giftopnm %(res_opt)s %(filelist)s %(flcmovie)s' % vars()
      print cmd
      os.system(cmd)

   finally:
      cmd = '/bin/rm %(prefix)s*' % vars()
      os.system(cmd)
      pass

if __name__ == '__main__':
   if len(sys.argv) != 3:
      print __doc__
      sys.exit()
   convert(sys.argv[1], sys.argv[2])



