#!/usr/bin/python

import os, string, sys

def yn_query(query, optionstr, **choices):
   ## yn_query usage:
   #    yn_query('perform this action?', 'y', 'n', 'q', default='n', auto=0)
   #    yn_query('perform this action?', 'yq', default='y', auto=0)
   
   '''
   python usage: yn_query(query, optionstr, **choices)
   shell usage: "yn_query"  (query is "perform this action?")

   This function poses the question in "query" and returns 
   1 if  answer  is yes
   0 if  answer  is no
   changes directories (if specified) and quits (if 'q')
   
   - query is a string
   - options is one string with 'y', 'n', or 'q', (as 'ynq')
   - choices can be any or all of several name=value pairs:
                      default='n'      (or some other member of \*options)
                      auto=0
                      auto=1
                      backtodir='somedirectory'
   
   including auto=1 does not ask, but returns as if the default were chosen
   
   '''
                      
   default = ''
   auto = 0
   backtodir = os.getcwd()
   
   for kw in choices.keys():
      if kw is 'default':
         default = choices[kw]
      elif kw is 'auto':
         auto = int(choices[kw])
      elif kw is 'backtodir':
         backtodir = choices[kw]
         
   olist = []
   for count in range(0, len(optionstr)):
      olist.append(optionstr[count])
   optionstr = string.join(olist, '/')
   prompt = query + ' [' +optionstr+ ']'+' [' +default+ '] '

   ## now adapt from perl query
   if (auto is 1):
      if ((default is 'n') or (default is 'y')):
         retval = (default == 'y')
         print 'yn_query automatically returning, with ', retval
         return retval
      if (default is 'q'):
         os.chdir(backtodir)
         sys.exit(1)
      
   ok = ''

   while not ok in olist:
      ok = raw_input(prompt)

      print 'DEBUG (yn_query): "ok" is <%s>' %ok
      
      if (ok is ''):
         print 'accepting default'
         ok = default
         if default == '': print 'no default available'

   if ((ok is 'q') or (ok is 'quit')):
      print 'changing directory to ...\n', backtodir, '\n... and quitting'
      os.chdir(backtodir)
      sys.exit(1)
            
   retval =  (ok is 'y')
   return retval

